/**********************************************************
FileName:    DlgVcaRuleCfg.cpp
Description: VCA Rule config and relate config      
Date:        2009/07/10
Note: 		
    <version> <time>         <desc>
    <1.0    > <2009/07/10>       <created>
***********************************************************/
// DlgVcaRuleCfg.cpp : implementation file
//

#include "stdafx.h"
#include "clientdemo.h"
#include "DlgVcaRuleCfg.h"
#include "IVMSEnterRegion.h"
#include "IVMSMaskRegion.h"
#include <math.h>
#include "gdiplus/GdiPlus.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
CDlgVcaRuleCfg *g_pDlgVcaRuleCfg;  
#define  AlarmLine 1
#define  AlarmArea 2
/////////////////////////////////////////////////////////////////////////////
// CDlgVcaRuleCfg dialog

/*********************************************************
Function:	DrawAlertShow
Desc:		Callback of Draw on preview
Input:	nPort that is Player Handle
hDc    : DC handle of player window
dwUser: User data
Output:	none
Return:	none
**********************************************************/
void CALLBACK DrawAlertShow(LONG lRealHandle, HDC hDc, DWORD dwUser)
{
	SetBkMode(hDc, TRANSPARENT);
	SetTextColor(hDc, RGB(255, 255, 255));
	if(g_pDlgVcaRuleCfg->m_bRuleActive)
	{
		g_pDlgVcaRuleCfg->F_DrawFun(lRealHandle, hDc, dwUser); 
	}
	
}

/*********************************************************
  Function:	CDlgVcaRuleCfg
  Desc:		Constructor
  Input:	
  Output:	
  Return:	
**********************************************************/
CDlgVcaRuleCfg::CDlgVcaRuleCfg(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgVcaRuleCfg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgVcaRuleCfg)
	m_bDSPAddRule = FALSE;
	m_bDSPAddTarget = FALSE;
	m_bPicAddRule = FALSE;
	m_bPicAddTarget = FALSE;
	m_bFilterActive = FALSE;
	m_bSetMaxFilter = FALSE;
	m_bSetMiniFilter = FALSE;
	m_bVcaActive = FALSE;
	m_bHandleType1 = FALSE;
	m_bHandleType2 = FALSE;
	m_bHandleType3 = FALSE;
	m_bHandleType4 = FALSE;
	m_bHandleType5 = FALSE;
	m_bDrawPolygon = FALSE;
	m_bRuleActive = FALSE;
	m_iBAdvanceChanNum = 0;
	m_iBBaseChanNum = 0;
	m_iBFullChanNum = 0;
	m_iPlateChanNum = 0;
	m_iVcaChanNum = 0;
	m_csRuleName = _T("");
	m_iHour11 = 0;
	m_iHour12 = 0;
	m_iHour21 = 0;
	m_iHour22 = 0;
	m_iMin11 = 0;
	m_iMin12 = 0;
	m_iMin21 = 0;
	m_iMin22 = 0;
	m_iAlarmDelay = 0;
	m_iAlarmPersist = 0;
	m_fMaxDistance = 0.0f;
	m_fDenstityRate = 0.0f;
	m_iReadCardTimePersist = 0;
	m_bDrawLine = FALSE;
	m_iAtmChanNum = 0;
	//}}AFX_DATA_INIT
	m_lServerID = -1;
	m_iStartChannel = -1;
	m_iDevIndex = -1;
	m_iChannelnumber = -1;
	m_dwAlarmOutNum = 0;
	m_iVcaChannel = -1;

    memset(&m_struVcaCtrlCfg, 0, sizeof(NET_VCA_CTRLCFG));
	memset(&m_struBehaviorAbility, 0, sizeof(NET_VCA_BEHAVIOR_ABILITY));
	memset(&m_struRuleCfg, 0, sizeof(NET_VCA_RULECFG));
	memset(&m_struOneRule, 0, sizeof(NET_VCA_ONE_RULE));
	memset(&m_struVCADrawMode, 0 ,sizeof(NET_VCA_DRAW_MODE));
	m_dwPosNum = 0;

	memset(&m_struVcaPolygon[0], 0, sizeof(NET_VCA_POLYGON)*MAX_RULE_NUM);
	memset(&m_struVcaLine[0], 0, sizeof(NET_VCA_LINE)*MAX_RULE_NUM);
	memset(&m_bCloseIn[0], 0, sizeof(BOOL)*MAX_RULE_NUM);
	memset(&m_bNeedRedraw[0], 0, sizeof(BOOL)*MAX_RULE_NUM);
	memset(&m_bMouseMove[0], 0, sizeof(BOOL)*MAX_RULE_NUM);
	memset(&m_struAlarmTime[0][0], 0, (MAX_DAYS*MAX_TIMESEGMENT_2*sizeof(NET_DVR_SCHEDTIME)));
	memset(&m_struVcaAtmEnterRegion, 0, sizeof(NET_VCA_ENTER_REGION));
	memset(&m_struVcaAtmMaskRegionList, 0, sizeof(NET_VCA_MASK_REGION_LIST));
	
	m_iCurRuleID = -1;
	memset(&m_rcWndRect, 0, sizeof(CRect));
	m_lPlayHandle = -1;

}

/*********************************************************
  Function:	DoDataExchange
  Desc:		the map between control and variable
  Input:	none
  Output:	none
  Return:	none
**********************************************************/
void CDlgVcaRuleCfg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgVcaRuleCfg)
	DDX_Control(pDX, IDC_STATIC_STICKUP_ALARM_PERSIST, m_staticStickupAlarmPersist);
	DDX_Control(pDX, IDC_COMBO_ATM_MODE2, m_comboAtmMode);
	DDX_Control(pDX, IDC_STATIC_ALARM_DIRECT, m_staticAlarmDirect);
	DDX_Control(pDX, IDC_COMLINEALARMDIRECT, m_comboAlarmDirect);
	DDX_Control(pDX, IDC_STATIC_MAX_DISTANCE_AREA, m_staticMaxDistanceArea);
	DDX_Control(pDX, IDC_STATIC_DENSTITY_RATE_AREA, m_staticDenstityRateArea);
	DDX_Control(pDX, IDC_STATIC_ALARM_PERSIST_AREA, m_staticAlarmPersistArea);
	DDX_Control(pDX, IDC_STATIC_ALARM_DELAY_AREA, m_staticAlarmDelayArea);
	DDX_Control(pDX, IDC_STATIC_READ_CARD_TIME_PERSIST_AREA2, m_staticReadCardTimePersistArea);
	DDX_Control(pDX, IDC_EDIT_ALARM_PERSIST, m_editAlarmPersist);
	DDX_Control(pDX, IDC_EDIT_DENSTITY_RATE, m_editDenstityRate);
	DDX_Control(pDX, IDC_EDIT_READ_CARD_TIME_PERSIST, m_editReadCardTimePersist);
	DDX_Control(pDX, IDC_EDIT_MAX_DISTANCE, m_editMaxDistance);
	DDX_Control(pDX, IDC_EDIT_ALARM_DELAY, m_editAlarmDelay);
	DDX_Control(pDX, IDC_STATIC_READ_CARD_TIME_PERSIST, m_staticReadCardTimePersist);
	DDX_Control(pDX, IDC_STATIC_MAX_DISTANCE, m_staticMaxDistance);
	DDX_Control(pDX, IDC_STATIC_DENSTITY_RATE, m_staticDenstityRate);
	DDX_Control(pDX, IDC_STATIC_ALARM_PERSIST, m_staticAlarmPersist);
	DDX_Control(pDX, IDC_STATIC_ALARM_DELAY, m_staticAlarmDelay);
	DDX_Control(pDX, IDC_LIST_RECORD_CHAN, m_listRecordChan);
	DDX_Control(pDX, IDC_LIST_ALARM_OUT, m_listAlarmOut);
	DDX_Control(pDX, IDC_COMBOWEEKDAY, m_comboWeekday);
	DDX_Control(pDX, IDC_COMBOCOPYTIME, m_comboCopyTime);
	DDX_Control(pDX, IDC_COMBO_VCA_TYPE, m_comboVcaType);
	DDX_Control(pDX, IDC_COMBO_VCA_CHAN, m_comboVcaChan);
	DDX_Control(pDX, IDC_COMBO_STREAM, m_comboStream);
	DDX_Control(pDX, IDC_COMBO_SENSITIVE, m_comboSensitive);
	DDX_Control(pDX, IDC_COMBO_RULE_TYPE, m_comboRuleType);
	DDX_Control(pDX, IDC_COMBO_RULE_ID, m_comboRuleID);
	DDX_Control(pDX, IDC_COMBO_RESOLUTION, m_comboResolution);
	DDX_Control(pDX, IDC_COMBO_PRO_PIC_TYPE, m_comboProPicType);
	DDX_Control(pDX, IDC_COMBO_PIC_QUALITY, m_comboPicQuality);
	DDX_Check(pDX, IDC_CHECK_DSP_ADD_RULE, m_bDSPAddRule);
	DDX_Check(pDX, IDC_CHECK_DSP_ADD_TARGET, m_bDSPAddTarget);
	DDX_Check(pDX, IDC_CHECK_PIC_ADD_RULE, m_bPicAddRule);
	DDX_Check(pDX, IDC_CHECK_PIC_ADD_TARGET, m_bPicAddTarget);
	DDX_Check(pDX, IDC_CHECK_FILTER_ACTIVE, m_bFilterActive);
	DDX_Check(pDX, IDC_CHECK_SET_MAX_FILTER, m_bSetMaxFilter);
	DDX_Check(pDX, IDC_CHECK_SET_MINI_FILTER, m_bSetMiniFilter);
	DDX_Check(pDX, IDC_CHECK_VCA_ACTIVE, m_bVcaActive);
	DDX_Check(pDX, IDC_CHECKHANDLETYPE1, m_bHandleType1);
	DDX_Check(pDX, IDC_CHECKHANDLETYPE2, m_bHandleType2);
	DDX_Check(pDX, IDC_CHECKHANDLETYPE3, m_bHandleType3);
	DDX_Check(pDX, IDC_CHECKHANDLETYPE4, m_bHandleType4);
	DDX_Check(pDX, IDC_CHECKHANDLETYPE5, m_bHandleType5);
	DDX_Check(pDX, IDC_CHK_DRAW_POLYGON, m_bDrawPolygon);
	DDX_Check(pDX, IDC_CHK_RULE_ACTIVE, m_bRuleActive);
	DDX_Text(pDX, IDC_EDIT_BADVANCE_CHAN_NUM, m_iBAdvanceChanNum);
	DDX_Text(pDX, IDC_EDIT_BBASE_CHAN_NUM, m_iBBaseChanNum);
	DDX_Text(pDX, IDC_EDIT_BFULL_CHAN_NUM, m_iBFullChanNum);
	DDX_Text(pDX, IDC_EDIT_PLATE_CHAN_NUM1, m_iPlateChanNum);
	DDX_Text(pDX, IDC_EDIT_VCA_CHAN_NUM, m_iVcaChanNum);
	DDX_Text(pDX, IDC_EDIT_RULE_NAME, m_csRuleName);
	DDV_MaxChars(pDX, m_csRuleName, 31);
	DDX_Text(pDX, IDC_EDITHOUR11, m_iHour11);
	DDX_Text(pDX, IDC_EDITHOUR12, m_iHour12);
	DDX_Text(pDX, IDC_EDITHOUR21, m_iHour21);
	DDX_Text(pDX, IDC_EDITHOUR22, m_iHour22);
	DDX_Text(pDX, IDC_EDITMIN11, m_iMin11);
	DDX_Text(pDX, IDC_EDITMIN12, m_iMin12);
	DDX_Text(pDX, IDC_EDITMIN21, m_iMin21);
	DDX_Text(pDX, IDC_EDITMIN22, m_iMin22);
	DDX_Text(pDX, IDC_EDIT_ALARM_DELAY, m_iAlarmDelay);
	DDX_Text(pDX, IDC_EDIT_ALARM_PERSIST, m_iAlarmPersist);
	DDX_Text(pDX, IDC_EDIT_MAX_DISTANCE, m_fMaxDistance);
	DDX_Text(pDX, IDC_EDIT_DENSTITY_RATE, m_fDenstityRate);
	DDX_Text(pDX, IDC_EDIT_READ_CARD_TIME_PERSIST, m_iReadCardTimePersist);
	DDX_Check(pDX, IDC_CHK_DRAW_LINE, m_bDrawLine);
	DDX_Text(pDX, IDC_EDIT_ATM_CHAN_NUM, m_iAtmChanNum);
	//}}AFX_DATA_MAP
}

/*********************************************************
Function:	BEGIN_MESSAGE_MAP
Desc:		the map between control and function
Input:	
Output:	
Return:	
**********************************************************/
BEGIN_MESSAGE_MAP(CDlgVcaRuleCfg, CDialog)
	//{{AFX_MSG_MAP(CDlgVcaRuleCfg)
	ON_BN_CLICKED(ID_BTN_SET_RULE_CFG, OnBtnSetRuleCfg)
	ON_BN_CLICKED(ID_BTN_SET_VCA_CTRL, OnBtnSetVcaCtrl)
	ON_BN_CLICKED(IDC_BTN_REFESH, OnBtnRefesh)
	ON_BN_CLICKED(IDC_BTN_SET_ONE_RULE, OnBtnSetOneRule)
	ON_BN_CLICKED(IDC_BTN_VCA_RESTART, OnBtnVcaRestart)
	ON_BN_CLICKED(IDC_BTN_SET_VCA_DRAW_MODE, OnBtnSetVcaDrawMode)
	ON_CBN_SELCHANGE(IDC_COMBO_VCA_CHAN, OnSelchangeComboVcaChan)
	ON_BN_CLICKED(IDC_CHECK_VCA_ACTIVE, OnCheckVcaActive)
	ON_CBN_SELCHANGE(IDC_COMBO_RULE_ID, OnSelchangeComboRuleId)
	ON_BN_CLICKED(IDC_CHK_RULE_ACTIVE, OnChkRuleActive)
	ON_CBN_SELCHANGE(IDC_COMBO_RULE_TYPE, OnSelchangeComboRuleType)
	ON_BN_CLICKED(IDC_CHK_DRAW_POLYGON, OnChkDrawPolygon)
	ON_BN_CLICKED(IDC_CHECK_FILTER_ACTIVE, OnCheckFilterActive)
	ON_BN_CLICKED(IDC_CHECK_SET_MINI_FILTER, OnCheckSetMiniFilter)
	ON_BN_CLICKED(IDC_CHECK_SET_MAX_FILTER, OnCheckSetMaxFilter)
	ON_BN_CLICKED(IDC_CHK_DRAW_LINE, OnChkDrawLine)
	ON_CBN_SELCHANGE(IDC_COMLINEALARMDIRECT, OnSelchangeComlinealarmdirect)
	ON_BN_CLICKED(IDC_TIME_OK, OnTimeOk)
	ON_BN_CLICKED(IDC_TIME_COPY, OnTimeCopy)
	ON_CBN_SELCHANGE(IDC_COMBOWEEKDAY, OnSelchangeComboweekday)
	ON_BN_CLICKED(IDC_CHECKHANDLETYPE4, OnCheckhandletype4)
	ON_EN_CHANGE(IDC_EDIT_RULE_NAME, OnChangeEditRuleName)
	ON_EN_CHANGE(IDC_EDIT_ALARM_DELAY, OnChangeEditAlarmDelay)
	ON_EN_CHANGE(IDC_EDIT_ALARM_PERSIST, OnChangeEditAlarmPersist)
	ON_EN_CHANGE(IDC_EDIT_DENSTITY_RATE, OnChangeEditDenstityRate)
	ON_EN_CHANGE(IDC_EDIT_MAX_DISTANCE, OnChangeEditMaxDistance)
	ON_EN_CHANGE(IDC_EDIT_READ_CARD_TIME_PERSIST, OnChangeEditReadCardTimePersist)
	ON_BN_CLICKED(IDC_BTN_ENTER_REGION2, OnBtnEnterRegion)
	ON_BN_CLICKED(IDC_BTN_MASK_REGION, OnBtnMaskRegion)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgVcaRuleCfg message handlers

BOOL CDlgVcaRuleCfg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	CPoint pt(0,0);
	CRect  rcWnd(0,0,0,0);
	GetDlgItem(IDC_PLAYWND)->GetWindowRect(&rcWnd);
	GetCursorPos(&pt);
	CString strTemp = _T("");
	DWORD i=0;
	BOOL bOneLine = TRUE,bXOneLine = TRUE,bYOneLine = TRUE;

	switch(pMsg->message)  // Message of Draw
	{
	case WM_LBUTTONDOWN:
		if( (m_bDrawLine || m_bDrawPolygon)&&
			(GetAsyncKeyState(VK_LCONTROL)<0 || GetAsyncKeyState(VK_RCONTROL)<0))//Press CTRL to draw
		{
			if (m_bDrawPolygon)// Draw polygon
			{
				if(PtInRect(&rcWnd,pt))
				{	
					if(m_bNeedRedraw[m_iCurRuleID])
					{			
						if(m_bCloseIn[m_iCurRuleID])
						{
							m_dwPosNum = 0;
							m_struVcaPolygon[m_iCurRuleID].dwPointNum = m_dwPosNum;		
						}
						if(m_dwPosNum>9)
						{
							char szLan[128] = {0};
							g_StringLanType(szLan,"ζ㲻ܳ10!","Apexes of polygon should less than 11");
							AfxMessageBox(szLan);
							return TRUE;
						}
						if((float)(pt.x-rcWnd.left)/(float)rcWnd.Width() <= m_struVcaPolygon[m_iCurRuleID].struPos[m_dwPosNum-1].fX+0.01 && (float)(pt.x-rcWnd.left)/(float)rcWnd.Width() >= m_struVcaPolygon[m_iCurRuleID].struPos[m_dwPosNum-1].fX-0.01\
							&& (float)(pt.y-rcWnd.top)/(float)rcWnd.Height() <= m_struVcaPolygon[m_iCurRuleID].struPos[m_dwPosNum-1].fY+0.01 && (float)(pt.y-rcWnd.top)/(float)rcWnd.Height() >= m_struVcaPolygon[m_iCurRuleID].struPos[m_dwPosNum-1].fY-0.01)
						{
							char szLan[128] = {0};
							g_StringLanType(szLan, "ͬһϻ", "Can't draw region on the point used");
							AfxMessageBox(szLan);
							return TRUE;
						}
						m_bCloseIn[m_iCurRuleID] = FALSE;
						m_bMouseMove[m_iCurRuleID] = FALSE;
						m_struVcaPolygon[m_iCurRuleID].struPos[m_dwPosNum].fX = (float)(pt.x-rcWnd.left)/(float)rcWnd.Width();
						m_struVcaPolygon[m_iCurRuleID].struPos[m_dwPosNum].fY = (float)(pt.y-rcWnd.top)/(float)rcWnd.Height();
						m_dwPosNum++;
						m_struVcaPolygon[m_iCurRuleID].dwPointNum = m_dwPosNum;			
					}
					else
					{
						return TRUE;
					}
				}
			}
			if (m_bDrawLine) 
			{
				if(PtInRect(&rcWnd,pt))
				{		
					if(!m_bMouseMove[m_iCurRuleID])
					{
						m_struVcaLine[m_iCurRuleID].struStart.fX = (float)(pt.x-rcWnd.left)/(float)rcWnd.Width();
						m_struVcaLine[m_iCurRuleID].struStart.fY = (float)(pt.y-rcWnd.top)/(float)rcWnd.Height();		
						m_struVcaLine[m_iCurRuleID].struEnd.fX = (float)(pt.x-rcWnd.left)/(float)rcWnd.Width();
						m_struVcaLine[m_iCurRuleID].struEnd.fY = (float)(pt.y-rcWnd.top)/(float)rcWnd.Height();			
						m_bMouseMove[m_iCurRuleID] = TRUE;
					}
					else
					{
						if ((float)(pt.x-rcWnd.left)/(float)rcWnd.Width() <= m_struVcaLine[m_iCurRuleID].struStart.fX+0.01 && (float)(pt.x-rcWnd.left)/(float)rcWnd.Width() >= m_struVcaLine[m_iCurRuleID].struStart.fX-0.01\
							&& (float)(pt.y-rcWnd.top)/(float)rcWnd.Height() <= m_struVcaLine[m_iCurRuleID].struStart.fY+0.01 && (float)(pt.y-rcWnd.top)/(float)rcWnd.Height() >= m_struVcaLine[m_iCurRuleID].struStart.fY-0.01)
						{
							char szLan[128] = {0};
							g_StringLanType(szLan, "ͬһϻ", "Can't draw region on the point used");
							AfxMessageBox(szLan);
							return TRUE;
						}
						m_struVcaLine[m_iCurRuleID].struEnd.fX = (float)(pt.x-rcWnd.left)/(float)rcWnd.Width();
						m_struVcaLine[m_iCurRuleID].struEnd.fY = (float)(pt.y-rcWnd.top)/(float)rcWnd.Height();			
						m_bMouseMove[m_iCurRuleID] = FALSE;
					}
					
				}
				else
				{
					return TRUE;
				}
			}
			
		}//First coordinate of Minimal Rectangle
		else if(m_bSetMiniFilter && (GetAsyncKeyState(VK_LCONTROL)<0 || GetAsyncKeyState(VK_RCONTROL)<0))
		{
			if(PtInRect(&rcWnd,pt))
			{
			m_struOneRule.struSizeFilter.struMiniRect.fX = (float)(pt.x-rcWnd.left)/(float)rcWnd.Width();
			m_struOneRule.struSizeFilter.struMiniRect.fY = (float)(pt.y-rcWnd.top)/(float)rcWnd.Height();
			}
		}//First coordinate of Maximal Rectangle
		else if(m_bSetMaxFilter && (GetAsyncKeyState(VK_LCONTROL)<0 || GetAsyncKeyState(VK_RCONTROL)<0))
		{
			if(PtInRect(&rcWnd,pt))
			{
			m_struOneRule.struSizeFilter.struMaxRect.fX = (float)(pt.x-rcWnd.left)/(float)rcWnd.Width();
			m_struOneRule.struSizeFilter.struMaxRect.fY = (float)(pt.y-rcWnd.top)/(float)rcWnd.Height();
		}
		}
		break;
	case WM_MOUSEMOVE:
		if((m_bDrawLine || m_bDrawPolygon)&&(GetAsyncKeyState(VK_LCONTROL)<0 || GetAsyncKeyState(VK_RCONTROL)<0))
		{
			if (m_bDrawPolygon)
			{
				if(PtInRect(&rcWnd,pt))
				{
					if(m_dwPosNum > 9)
					{
						return TRUE;
					}
					if( m_bNeedRedraw[m_iCurRuleID] && !m_bCloseIn[m_iCurRuleID])
					{
						m_bMouseMove[m_iCurRuleID] = TRUE;
						m_struVcaPolygon[m_iCurRuleID].struPos[m_dwPosNum].fX = (float)(pt.x-rcWnd.left)/(float)rcWnd.Width();
						m_struVcaPolygon[m_iCurRuleID].struPos[m_dwPosNum].fY = (float)(pt.y-rcWnd.top)/(float)rcWnd.Height();
						m_struVcaPolygon[m_iCurRuleID].dwPointNum = m_dwPosNum+1;				
					}
				}
			}
			
			if(m_bDrawLine)
			{
				if(PtInRect(&rcWnd,pt))
				{
					if(m_bMouseMove)
					{
						m_struVcaLine[m_iCurRuleID].struEnd.fX = (float)(pt.x-rcWnd.left)/(float)rcWnd.Width();
						m_struVcaLine[m_iCurRuleID].struEnd.fY = (float)(pt.y-rcWnd.top)/(float)rcWnd.Height();			
					}
				}
			}
		}
		else if(m_bSetMiniFilter && (GetAsyncKeyState(VK_LCONTROL)<0 || GetAsyncKeyState(VK_RCONTROL)<0)) //ߴ
		{
			if(PtInRect(&rcWnd,pt))
			{
			m_struOneRule.struSizeFilter.struMiniRect.fWidth = (float)(pt.x-rcWnd.left)/(float)rcWnd.Width() - m_struOneRule.struSizeFilter.struMiniRect.fX;
			m_struOneRule.struSizeFilter.struMiniRect.fHeight = (float)(pt.y-rcWnd.top)/(float)rcWnd.Height() - m_struOneRule.struSizeFilter.struMiniRect.fY;
			}
	
		}
		else if(m_bSetMaxFilter && (GetAsyncKeyState(VK_LCONTROL)<0 || GetAsyncKeyState(VK_RCONTROL)<0)) //ߴ
		{
			if(PtInRect(&rcWnd,pt))
			{	
			m_struOneRule.struSizeFilter.struMaxRect.fWidth = (float)(pt.x-rcWnd.left)/(float)rcWnd.Width() - m_struOneRule.struSizeFilter.struMaxRect.fX;
			m_struOneRule.struSizeFilter.struMaxRect.fHeight = (float)(pt.y-rcWnd.top)/(float)rcWnd.Height() - m_struOneRule.struSizeFilter.struMaxRect.fY;
		}
		}
		break;
	case WM_RBUTTONDOWN://Click right mouse to close the rectangle. 
		if(m_bDrawPolygon && (GetAsyncKeyState(VK_LCONTROL)<0 || GetAsyncKeyState(VK_RCONTROL)<0))
		{
			if(PtInRect(&rcWnd,pt))
			{
				if(m_dwPosNum > 9)
				{
					return TRUE;
				}
				for(i=0; i<m_dwPosNum; i++)
				{
					if(m_struVcaPolygon[m_iCurRuleID].struPos[i].fX != m_struVcaPolygon[m_iCurRuleID].struPos[i+1].fX)
					{
						bXOneLine = FALSE;
						break;
					}
				}
				for(i=0; i<m_dwPosNum; i++)
				{
					if(m_struVcaPolygon[m_iCurRuleID].struPos[i].fY != m_struVcaPolygon[m_iCurRuleID].struPos[i+1].fY)
					{
						bYOneLine = FALSE;
						break;
					}
				}
				bOneLine = bXOneLine||bYOneLine;
				if(bOneLine)
				{
					char szlan[128] = {0};
					g_StringLanType(szlan, "һߣ޷!","The points is on a line and can't create a rectangle!");
					AfxMessageBox(szlan);
					return TRUE;
				}
				if( m_bNeedRedraw[m_iCurRuleID] && !m_bCloseIn[m_iCurRuleID])
				{
					if(m_bMouseMove[m_iCurRuleID])
					{
						m_bMouseMove[m_iCurRuleID] = FALSE;
						m_struVcaPolygon[m_iCurRuleID].dwPointNum--;
						m_struVcaPolygon[m_iCurRuleID].struPos[m_struVcaPolygon[m_iCurRuleID].dwPointNum].fX = 0;
						m_struVcaPolygon[m_iCurRuleID].struPos[m_struVcaPolygon[m_iCurRuleID].dwPointNum].fY = 0;
					}
					m_bCloseIn[m_iCurRuleID] = TRUE;
				}
			}
		}
		else if(m_bDrawPolygon)
		{
			if(PtInRect(&rcWnd,pt))
			{
				if(m_dwPosNum == 0)
				{
					return TRUE;
				}
				if( m_bNeedRedraw[m_iCurRuleID] && !m_bCloseIn[m_iCurRuleID])
				{
					m_struVcaPolygon[m_iCurRuleID].dwPointNum--;
					m_dwPosNum--;
					m_struVcaPolygon[m_iCurRuleID].struPos[m_struVcaPolygon[m_iCurRuleID].dwPointNum].fX = 0;
					m_struVcaPolygon[m_iCurRuleID].struPos[m_struVcaPolygon[m_iCurRuleID].dwPointNum].fY = 0;
				}
				else if( m_bNeedRedraw[m_iCurRuleID] && m_bCloseIn[m_iCurRuleID])
				{
					m_struVcaPolygon[m_iCurRuleID].dwPointNum = 0;
					m_dwPosNum = 0;
					m_bCloseIn[m_iCurRuleID] = FALSE;
				}
			}
		}
		break;
	default:
		break;
	}
	return CDialog::PreTranslateMessage(pMsg);
}

/*********************************************************
  Function:	OnInitDialog
  Desc:		 
  Input:	
  Output:	
  Return:	
**********************************************************/
BOOL CDlgVcaRuleCfg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	// TODO: Add extra initialization here

	CRect rect;
	GetDlgItem(IDC_PLAYWND)->GetWindowRect(&rect);
	ScreenToClient(&rect);
	int nWidth = (int)((rect.Height()*352)/288);
	rect.left  += (long)fabs(rect.right - rect.left - nWidth)/2;
	rect.right = rect.left + nWidth;
	
	GetDlgItem(IDC_PLAYWND)->MoveWindow(rect);

	g_pDlgVcaRuleCfg = this; // 
	m_iVcaChannel = m_iStartChannel;	
	m_dwAlarmOutNum = g_struDeviceInfo[m_iDevIndex].iAlarmOutNum;
	GetDevVcaChanPara();//Get channel info
	
	
	EnableVcaWindow(g_pMainDlg->m_struVcaCtrlCfg.struCtrlInfo[m_iVcaChannel-1].byVCAEnable); 

	NET_VCA_CHAN_IN_PARAM struVcaChanInparam;
	memset(&struVcaChanInparam, 0 ,sizeof(NET_VCA_CHAN_IN_PARAM));
	struVcaChanInparam.byVCAType = g_pMainDlg->m_struVcaCtrlCfg.struCtrlInfo[m_iVcaChannel-1].byVCAType;
	struVcaChanInparam.byMode = g_pMainDlg->m_struVcaCtrlCfg.struCtrlInfo[m_iVcaChannel-1].byMode;
	
	m_iCurRuleID = 0;

	GetVcaPara(m_iVcaChannel, struVcaChanInparam);

	
	RefreshOneRule(m_struOneRule);

	
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/*********************************************************
  Function:	OnBtnSetRuleCfg
  Desc:		
  Input:	
  Output:	
  Return:	void
**********************************************************/
void CDlgVcaRuleCfg::OnBtnSetRuleCfg() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_struRuleCfg.byPicProType = (unsigned char)m_comboProPicType.GetCurSel();
	m_struRuleCfg.struPictureParam.wPicSize = (unsigned short)m_comboResolution.GetCurSel();
	m_struRuleCfg.struPictureParam.wPicQuality = (unsigned short)m_comboPicQuality.GetCurSel();
	SetRuleBehaviorCfg();
}

/*********************************************************
  Function:	OnBtnSetVcaCtrl
  Desc:		Set Button function for VCA control
  Input:	
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::OnBtnSetVcaCtrl() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int nChanIndex;
	nChanIndex = m_comboVcaChan.GetCurSel()+1;
	
	m_struVcaCtrlCfg.struCtrlInfo[nChanIndex-1].byVCAEnable = (unsigned char)m_bVcaActive;
	m_struVcaCtrlCfg.struCtrlInfo[nChanIndex-1].byVCAType = (unsigned char)m_comboVcaType.GetItemData(m_comboVcaType.GetCurSel());
	m_struVcaCtrlCfg.struCtrlInfo[nChanIndex-1].byStreamWithVCA = (unsigned char)m_comboStream.GetCurSel();
	
	if (m_struVcaCtrlCfg.struCtrlInfo[nChanIndex-1].byVCAType == VCA_ATM)
	{
		GetDlgItem(IDC_STATIC_ATM_MODE)->ShowWindow(SW_SHOW);
		m_comboAtmMode.ShowWindow(SW_SHOW);
		m_struVcaCtrlCfg.struCtrlInfo[nChanIndex-1].byMode = (BYTE)m_comboAtmMode.GetCurSel();
	}
	else
	{
		GetDlgItem(IDC_STATIC_ATM_MODE)->ShowWindow(SW_HIDE);
		m_comboAtmMode.ShowWindow(SW_HIDE);
	}

	if(!NET_DVR_SetDVRConfig(m_lServerID, NET_DVR_SET_VCA_CTRLCFG, nChanIndex , &m_struVcaCtrlCfg, sizeof(NET_VCA_CTRLCFG)))
	{	
		
		char sbuf[128];
		sprintf(sbuf, "NET_DVR_SET_VCA_CTRLCFG ch%d failed", nChanIndex);
		AfxMessageBox(sbuf);
		memcpy(&m_struVcaCtrlCfg, &g_pMainDlg->m_struVcaCtrlCfg,sizeof(NET_VCA_CTRLCFG));
		
		UpdateData(TRUE);
		m_comboVcaType.SetCurSel(m_struVcaCtrlCfg.struCtrlInfo[nChanIndex-1].byVCAType-1);
		m_bVcaActive = m_struVcaCtrlCfg.struCtrlInfo[nChanIndex-1].byVCAEnable;
		m_comboStream.SetCurSel(m_struVcaCtrlCfg.struCtrlInfo[nChanIndex-1].byStreamWithVCA);

		if (m_struVcaCtrlCfg.struCtrlInfo[nChanIndex-1].byVCAType == VCA_ATM)
		{
			GetDlgItem(IDC_STATIC_ATM_MODE)->ShowWindow(SW_SHOW);
			m_comboAtmMode.ShowWindow(SW_SHOW);
			m_comboAtmMode.SetCurSel(m_struVcaCtrlCfg.struCtrlInfo[nChanIndex-1].byMode);
		}
		else
		{
			GetDlgItem(IDC_STATIC_ATM_MODE)->ShowWindow(SW_HIDE);
			m_comboAtmMode.ShowWindow(SW_HIDE);
		}

		UpdateData(FALSE);
		
	}
	else
	{
		memcpy(&g_pMainDlg->m_struVcaCtrlCfg, &m_struVcaCtrlCfg,sizeof(NET_VCA_CTRLCFG));//copy as a globe member
		char sbuf[128];
		sprintf(sbuf, "NET_DVR_SET_VCA_CTRLCFG ch%d successfully", nChanIndex);
		AfxMessageBox(sbuf);
		
		NET_VCA_CHAN_IN_PARAM struVcaChanInPara;
		memset(&struVcaChanInPara, 0, sizeof(NET_VCA_CHAN_IN_PARAM));
		struVcaChanInPara.byVCAType = m_struVcaCtrlCfg.struCtrlInfo[nChanIndex-1].byVCAType;
		struVcaChanInPara.byMode = m_struVcaCtrlCfg.struCtrlInfo[nChanIndex-1].byMode;
		GetVcaPara(nChanIndex, struVcaChanInPara);		
	}
}

/*********************************************************
  Function:	OnBtnRefesh
  Desc:		
  Input:	
  Output:	
  Return:	void
**********************************************************/
void CDlgVcaRuleCfg::OnBtnRefesh() 
{
	// TODO: Add your control notification handler code here
	OnInitDialog();
}

/*********************************************************
  Function:	OnBtnSetOneRule
  Desc:		
  Input:	
  Output:	
  Return:	void
**********************************************************/
void CDlgVcaRuleCfg::OnBtnSetOneRule() 
{
	// TODO: Add your control notification handler code here
	SetOneRule(m_struOneRule);
}

/*********************************************************
  Function:	OnBtnVcaRestart
  Desc:		Reboot VCA library 
  Input:	
  Output:	
  Return:	void
**********************************************************/
void CDlgVcaRuleCfg::OnBtnVcaRestart() 
{
	// TODO: Add your control notification handler code here
	char szLan[128] = {0};
	if (!NET_VCA_RestartLib(m_lServerID, m_iVcaChannel))
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_VCA_RestartLib %d", m_iVcaChannel);
		char sBufCn[128] =  {0};
		char sBufEn[128] = {0};
		sprintf(sBufCn, "ͨ%dܿʧ", m_iVcaChannel);
		sprintf(sBufEn, "VcaChannel%d failed to restart VCA library", m_iVcaChannel);
		g_StringLanType(szLan, sBufCn, sBufEn);
		AfxMessageBox(szLan);
	}
	else
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_VCA_RestartLib %d", m_iVcaChannel);
	}
}

/*********************************************************
  Function:	OnBtnSetVcaDrawMode
  Desc:		Ŀģʽ
  Input:	
  Output:	
  Return:	void
**********************************************************/
void CDlgVcaRuleCfg::OnBtnSetVcaDrawMode() 
{
	// TODO: Add your control notification handler code here
	SetVcaDrawMode();
}

/*********************************************************
Function:	GetDevVcaChanPara
Desc:		Get Channel Info from Device VCA Ability
Input:	
Output:	
Return:	void
**********************************************************/
void CDlgVcaRuleCfg::GetDevVcaChanPara()
{
	m_iVcaChanNum = g_pMainDlg->m_struVcaDevAbility.byVCAChanNum;
	m_iPlateChanNum = g_pMainDlg->m_struVcaDevAbility.byPlateChanNum;
	m_iAtmChanNum = g_pMainDlg->m_struVcaDevAbility.byATMChanNum;
	m_iBBaseChanNum = g_pMainDlg->m_struVcaDevAbility.byBBaseChanNum;
	m_iBAdvanceChanNum = g_pMainDlg->m_struVcaDevAbility.byBAdvanceChanNum;
	m_iBFullChanNum = g_pMainDlg->m_struVcaDevAbility.byBFullChanNum;

	UpdateData(FALSE);

	memset(&m_struVcaCtrlCfg, 0,sizeof(NET_VCA_CTRLCFG));
	memcpy(&m_struVcaCtrlCfg, &g_pMainDlg->m_struVcaCtrlCfg,sizeof(NET_VCA_CTRLCFG));
	char sbuf[128];
	for (int i = 0; i < m_iVcaChanNum; i++)
	{
		sprintf(sbuf, "VCA Chan%d", i+1);
		m_comboVcaChan.InsertString(i,sbuf);
	}
	
	m_comboVcaChan.SetCurSel(0);
	InsertComboVcaType(); 
	OnSelchangeComboVcaChan();	
}

/*********************************************************
  Function:	OnSelchangeComboVcaChan
  Desc:		Modify combo Control
  Input:	
  Output:	
  Return:	void
**********************************************************/
void CDlgVcaRuleCfg::OnSelchangeComboVcaChan() 
{
	// TODO: Add your control notification handler code here

	UpdateData(TRUE);
	m_iVcaChannel = m_comboVcaChan.GetCurSel()+1;
	SetComboVcaType();
	m_bVcaActive = m_struVcaCtrlCfg.struCtrlInfo[m_iVcaChannel-1].byVCAEnable;
	EnableVcaWindow(m_bVcaActive);
	m_comboStream.SetCurSel(m_struVcaCtrlCfg.struCtrlInfo[m_iVcaChannel-1].byStreamWithVCA);

	if (m_struVcaCtrlCfg.struCtrlInfo[m_iVcaChannel-1].byVCAType == VCA_ATM)
	{
		GetDlgItem(IDC_STATIC_ATM_MODE)->ShowWindow(SW_SHOW);
		m_comboAtmMode.ShowWindow(SW_SHOW);
		m_comboAtmMode.SetCurSel(m_struVcaCtrlCfg.struCtrlInfo[m_iVcaChannel-1].byMode);
	}
	else
	{
		GetDlgItem(IDC_STATIC_ATM_MODE)->ShowWindow(SW_HIDE);
		m_comboAtmMode.ShowWindow(SW_HIDE);
	}
	//Preview Rect
	//Ԥ
	NET_DVR_CLIENTINFO struPlay;
	GetDlgItem(IDC_PLAYWND)->GetWindowRect(&m_rcWndRect);
	struPlay.hPlayWnd 	= GetDlgItem(IDC_PLAYWND)->GetSafeHwnd();
	struPlay.lChannel 	= m_iVcaChannel; 
	struPlay.lLinkMode 	= 0;
	struPlay.sMultiCastIP = "";	
	
	if (m_lPlayHandle >= 0)
	{
		NET_DVR_StopRealPlay(m_lPlayHandle);
		m_lPlayHandle = -1;
	}
	else 
	{
	
	}

	m_lPlayHandle = NET_DVR_RealPlay_V30(m_lServerID, &struPlay, NULL, NULL, TRUE); 
	BOOL bRet = FALSE;
	if (m_lPlayHandle < 0)
	{
		g_pMainDlg->AddLog(-1, OPERATION_FAIL_T, "NET_DVR_RealPlay_V30");
		AfxMessageBox("NET_DVR_RealPlay_V30 FAIL");		
	}
	else
	{
		bRet = NET_DVR_RigisterDrawFun(m_lPlayHandle, DrawAlertShow, 0);//DC Draw callback
	}

	UpdateData(FALSE);

	
}

/*********************************************************
Function: EnableVcaWindow
Desc:	GUI Responding 
Input:	BOOL bEnable
Output:	
Return:	BOOL 
**********************************************************/
BOOL CDlgVcaRuleCfg::EnableVcaWindow(BOOL bEnable)
{
	GetDlgItem(IDC_COMBO_VCA_TYPE)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBO_STREAM)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBO_PRO_PIC_TYPE)->EnableWindow(bEnable);
	GetDlgItem(IDC_BTN_SET_ONE_RULE)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBO_RULE_TYPE)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBO_RESOLUTION)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHK_RULE_ACTIVE)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_RULE_NAME)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECK_DSP_ADD_TARGET)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECK_DSP_ADD_RULE)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECK_PIC_ADD_TARGET)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECK_PIC_ADD_RULE)->EnableWindow(bEnable);
	GetDlgItem(IDC_BTN_SET_VCA_DRAW_MODE)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBO_PIC_QUALITY)->EnableWindow(bEnable);
	GetDlgItem(IDC_BTN_VCA_RESTART)->EnableWindow(bEnable);
	GetDlgItem(IDC_BTN_VCA_BEHAVIOR_KEY)->EnableWindow(bEnable);
	GetDlgItem(IDC_BTN_MASK_REGION)->EnableWindow(bEnable);
	GetDlgItem(IDC_BTN_LF_CFG)->EnableWindow(bEnable);
	GetDlgItem(ID_BTN_SET_RULE_CFG)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECK_FILTER_ACTIVE)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECK_SET_MINI_FILTER)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHK_DRAW_POLYGON)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECK_SET_MAX_FILTER)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBO_SENSITIVE)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_ALARM_DELAY)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_ALARM_PERSIST)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECKHANDLETYPE1)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECKHANDLETYPE2)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECKHANDLETYPE3)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECKHANDLETYPE4)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITHOUR11)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITMIN11)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITHOUR12)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITMIN12)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITHOUR21)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITMIN21)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITHOUR22)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITMIN22)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBOWEEKDAY)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBOCOPYTIME)->EnableWindow(bEnable);
	GetDlgItem(IDC_TIME_COPY)->EnableWindow(bEnable);
	GetDlgItem(IDC_TIME_OK)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECKHANDLETYPE5)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_MAX_DISTANCE)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_DENSTITY_RATE)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_READ_CARD_TIME_PERSIST)->EnableWindow(bEnable);
	GetDlgItem(IDC_LIST_RECORD_CHAN)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBO_RULE_ID)->EnableWindow(bEnable);
	GetDlgItem(IDC_STATIC_ALARM_DIRECT)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMLINEALARMDIRECT)->EnableWindow(bEnable);
	GetDlgItem(IDC_LIST_ALARM_OUT)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHK_DRAW_LINE)->EnableWindow(bEnable);
	return TRUE;
}


/*********************************************************
  Function:	OnCheckVcaActive
  Desc:		
  Input:	
  Output:	
  Return:	void
**********************************************************/
void CDlgVcaRuleCfg::OnCheckVcaActive() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	EnableVcaWindow(m_bVcaActive);
	EnableRuleWindow(m_bVcaActive&&m_bRuleActive);
	UpdateData(FALSE);
}

/*********************************************************
Function:	GetVcaPara	
Desc:	Get VCA info 
Input:	int iChannel VCA Channel
		NET_VCA_CHAN_IN_PARAM struVcaChanInpara (Input Channel Ability parameter)
Output:	
Return:	BOOL 
**********************************************************/
BOOL CDlgVcaRuleCfg::GetVcaPara(int iChannel,NET_VCA_CHAN_IN_PARAM struVcaChanInpara)
{
	UNREFERENCED_PARAMETER(iChannel);

	char szLan[128] = {0};
	if(!NET_DVR_GetDeviceAbility(m_lServerID,  VCA_CHAN_ABILITY, (char*)&struVcaChanInpara, \
		sizeof(NET_VCA_CHAN_IN_PARAM), (char*)&m_struBehaviorAbility, sizeof(NET_VCA_BEHAVIOR_ABILITY)))
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "VCA_CHAN_ABILITY");
		g_StringLanType(szLan, "ȡͨʧ", "Fail to Get Channel Ability");
		AfxMessageBox(szLan);
		OnCancel();
		return FALSE;
	}
	else
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "VCA_CHAN_ABILITY");
	}
	
	if (!InsertRuleID(m_struBehaviorAbility.byMaxRuleNum)) //Insert Rule ID to ComboBox
	{
		return FALSE;
	}
	//set different Behavior according to different VCA Ability
	
	if(!InsertRuleType(m_struBehaviorAbility.dwAbilityType))
	{
		return FALSE;
	}
	//Get Config info
	if(!GetRuleCfg())
	{
		return FALSE;
	}
	//Get VCA info Overlay 
	if(!GetVcaDrawMode())
	{
		return FALSE;
	}
	UpdateData(FALSE);
	return TRUE;
}

/*********************************************************
Function:	InsertRuleType
Desc:	Insert Ability type in m_comboRuleType. 
Input:	int iBehaviorAbilityType
Output:	
Return:	BOOL 
**********************************************************/
BOOL CDlgVcaRuleCfg::InsertRuleType(int iBehaviorAbilityType)
{
	m_comboRuleType.ResetContent();
	char szLan[128] = {0};
	int index = 0;
	if((iBehaviorAbilityType&VCA_TRAVERSE_PLANE) != 0)
	{
		g_StringLanType(szLan, "Խ", "Traverse Plane");
		m_comboRuleType.InsertString(index, szLan);
		m_comboRuleType.SetItemData(index, VCA_TRAVERSE_PLANE);
		index++;
	}
	if((iBehaviorAbilityType&VCA_ENTER_AREA) != 0)
	{
		g_StringLanType(szLan, "", "Enter Area");
		m_comboRuleType.InsertString(index, szLan);
		m_comboRuleType.SetItemData(index, VCA_ENTER_AREA);
		index++;
	}
	if((iBehaviorAbilityType&VCA_EXIT_AREA) != 0)
	{
		g_StringLanType(szLan, "뿪", "Exit Area");
		m_comboRuleType.InsertString(index, szLan);
		m_comboRuleType.SetItemData(index, VCA_EXIT_AREA);
		index++;
	}
	if((iBehaviorAbilityType&VCA_INTRUSION) != 0)
	{
		g_StringLanType(szLan, "", "Intrusion");
		m_comboRuleType.InsertString(index, szLan);
		m_comboRuleType.SetItemData(index, VCA_INTRUSION);
		index++;
	}
	if((iBehaviorAbilityType&VCA_LOITER) != 0)
	{
		g_StringLanType(szLan, "ǻ", "Loiter");
		m_comboRuleType.InsertString(index, szLan);
		m_comboRuleType.SetItemData(index, VCA_LOITER);
		index++;
	}
	if((iBehaviorAbilityType&VCA_LEFT_TAKE) != 0)
	{
		g_StringLanType(szLan, "", "Left and Take");
		m_comboRuleType.InsertString(index, szLan);
		m_comboRuleType.SetItemData(index, VCA_LEFT_TAKE);
		index++;
	}
	if((iBehaviorAbilityType&VCA_PARKING) != 0)
	{
		g_StringLanType(szLan, "ͣ", "Parking");
		m_comboRuleType.InsertString(index, szLan);
		m_comboRuleType.SetItemData(index, VCA_PARKING);
		index++;
	}
	if((iBehaviorAbilityType&VCA_RUN) != 0)
	{
		g_StringLanType(szLan, "", "Running");
		m_comboRuleType.InsertString(index, szLan);
		m_comboRuleType.SetItemData(index, VCA_RUN);
		index++;
	}
	if((iBehaviorAbilityType&VCA_HIGH_DENSITY) != 0)
	{
		g_StringLanType(szLan, "Աܶ", "Staff Density");
		m_comboRuleType.InsertString(index, szLan);
		m_comboRuleType.SetItemData(index, VCA_HIGH_DENSITY);
		index++;
	}
	if((iBehaviorAbilityType&VCA_STICK_UP) != 0)
	{
		m_comboRuleType.InsertString(index, "ֽ");
		m_comboRuleType.SetItemData(index, VCA_STICK_UP);
		index++;
	}
	if ((iBehaviorAbilityType&VCA_INSTALL_SCANNER) != 0)
	{
		m_comboRuleType.InsertString(index, "װ");
		m_comboRuleType.SetItemData(index, (unsigned long)VCA_INSTALL_SCANNER);
		index++;
	}
	return TRUE;

}

/*********************************************************
Function:	InsertRuleID
Desc:	display rule ID in m_comboRuleID
Input:	
Output:	
Return:	BOOL 
**********************************************************/
BOOL CDlgVcaRuleCfg::InsertRuleID(int RuleNum)
{
    m_comboRuleID.ResetContent();
	char sbuf[128] = {0};
	for (int i= 0; i < RuleNum; i++)
	{	
		char szLan[128] = {0};
		char sBufCn[128] = {0};
		char sBufEn[128] = {0};
		sprintf(sBufCn, "%d", i);
		sprintf(sBufEn, "Rule%d", i);
		g_StringLanType(szLan,sBufCn,sBufEn);
		m_comboRuleID.InsertString(i,szLan);
	}
	return TRUE;
}

/*********************************************************
Function:	GetRuleCfg
Desc:	ȡΪ
Input:	
Output:	
Return:	BOOL 
**********************************************************/
BOOL CDlgVcaRuleCfg::GetRuleCfg()
{
	for(int i = 0;i<MAX_RULE_NUM; i++)
	{
		m_bNeedRedraw[i] = FALSE;//Redraw polygon
		m_bCloseIn[i] = TRUE;//Polygon is closed or not
	}
	
	memset(&m_struRuleCfg, 0,sizeof(NET_VCA_RULECFG));
	DWORD dwReturned;
	char szLan[128] = {0};
	if(!NET_DVR_GetDVRConfig(m_lServerID, NET_DVR_GET_RULECFG, m_iVcaChannel, &m_struRuleCfg, sizeof(NET_VCA_RULECFG), &dwReturned))	
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_DVR_GET_RULECFG %d", m_iVcaChannel);
		char sbufCn[128] = {0};
		char sbufEn[128] = {0};
		sprintf(sbufCn, "ȡͨ%dΪϢʧ",  m_iVcaChannel);
		sprintf(sbufEn, "Fail to get Channel%d VCA behavior rule", m_iVcaChannel);
		g_StringLanType(szLan, sbufCn, sbufEn);
		AfxMessageBox(szLan);
        OnCancel();
		return FALSE;
	}
	else
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_DVR_GET_RULECFG %d", m_iVcaChannel);
	}
	m_comboProPicType.SetCurSel(m_struRuleCfg.byPicProType); //get Action for alarm
	m_comboResolution.SetCurSel(m_struRuleCfg.struPictureParam.wPicSize);//Image resolution
	m_comboPicQuality.SetCurSel(m_struRuleCfg.struPictureParam.wPicQuality);//Image quality 0-best 1-better 2-normal
	
	m_comboRuleID.SetCurSel(0);
	m_iCurRuleID = 0;
	memcpy(&m_struOneRule, &m_struRuleCfg.struRule[m_iCurRuleID], sizeof(NET_VCA_ONE_RULE));
	
	m_bRuleActive = m_struOneRule.byActive;
	EnableRuleWindow(m_bRuleActive);
 	SetRuleActiveAble(m_bRuleActive);
 	//Config rule name
 	m_csRuleName = m_struOneRule.byRuleName;

	GetEventTypeSet(m_struOneRule.dwEventType);

	memcpy(&m_struAlarmTime[0][0],&m_struOneRule.struAlarmTime[0][0], MAX_DAYS*MAX_TIMESEGMENT_2*sizeof(NET_DVR_SCHEDTIME));
	return TRUE;
}

/*********************************************************
Function:	GetEventTypeSet
Desc:	Get Event type
Input:	VCA_EVENT_TYPE struEventType 58
Output:	
Return:	BOOL 
**********************************************************/
BOOL CDlgVcaRuleCfg::GetEventTypeSet(VCA_EVENT_TYPE struEventType)
{
	if (struEventType == 0)
	{
		return FALSE;
	}
	for (int i = 0;  i < 128; i++) //loop and compare m_comboRuleType
	{
		if((VCA_EVENT_TYPE)m_comboRuleType.GetItemData(i) == struEventType)
		{
			m_comboRuleType.SetCurSel(i);
			return TRUE;
		}
	}
	return FALSE;
}
/*********************************************************
Function:	SetRuleActiveAble
Desc:	
Input:	bEnable
Output:	
Return:	BOOL 
**********************************************************/
BOOL CDlgVcaRuleCfg::SetRuleActiveAble(BOOL bEnable)
{
	m_comboRuleType.EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_RULE_NAME)->EnableWindow(bEnable);
	return TRUE;
}

/*********************************************************
Function:	GetVcaDrawMode
Desc:		Get target added info
Input:	
Output:	
Return:	BOOL 
**********************************************************/
BOOL CDlgVcaRuleCfg::GetVcaDrawMode()
{
	memset(&m_struVCADrawMode, 0, sizeof(NET_VCA_DRAW_MODE));
	char szLan[128] = {0};
	if(!NET_DVR_GetVCADrawMode(m_lServerID,  m_iVcaChannel, &m_struVCADrawMode))	
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_VCA_DRAW_MODE %d", m_iVcaChannel);
		char sbufCn[128] = {0};
		char sbufEn[128] = {0};
		sprintf(sbufCn,"Get Target added info of channel %d failed", m_iVcaChannel);
		sprintf(sbufEn, "Get Target added info of channel %d failed");
		g_StringLanType(szLan, sbufCn, sbufEn);
		OnCancel();
		return FALSE;
	}
	else
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_VCA_DRAW_MODE %d", m_iVcaChannel);
	}
	m_bDSPAddRule = m_struVCADrawMode.byDspAddRule;
	m_bDSPAddTarget = m_struVCADrawMode.byDspAddTarget;
	m_bPicAddRule = m_struVCADrawMode.byDspPicAddRule;
	m_bPicAddTarget = m_struVCADrawMode.byDspPicAddTarget;
	return TRUE;
}

/*********************************************************
  Function:	OnSelchangeComboRuleId
  Desc:		Modify combo for rule ID
  Input:	
  Output:	
  Return:	void
**********************************************************/
void CDlgVcaRuleCfg::OnSelchangeComboRuleId() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_iCurRuleID = m_comboRuleID.GetCurSel();
	memcpy(&m_struOneRule, &m_struRuleCfg.struRule[m_iCurRuleID], sizeof(NET_VCA_ONE_RULE));
	m_bRuleActive = m_struOneRule.byActive;
	EnableRuleWindow(m_bRuleActive);
	SetRuleActiveAble(m_bRuleActive);
	//config rule name
	m_csRuleName = m_struOneRule.byRuleName;

	GetEventTypeSet(m_struOneRule.dwEventType);

	RefreshOneRule(m_struOneRule);
	UpdateData(FALSE);
}

/*********************************************************
Function:	RefreshOneRule
Desc:	refresh a rule
Input:	NET_VCA_ONE_RULE struVcaOneRule
Output:	
Return:	BOOL 
**********************************************************/
BOOL CDlgVcaRuleCfg::RefreshOneRule(NET_VCA_ONE_RULE struVcaOneRule)
{
	ShowRuleTypeWnd(struVcaOneRule.dwEventType); //setup display for different rules
	
	m_bHandleType1 = (struVcaOneRule.struHandleType.dwHandleType) &0x01;
	m_bHandleType2 = (struVcaOneRule.struHandleType.dwHandleType>>1)&0x01;
	m_bHandleType3 = (struVcaOneRule.struHandleType.dwHandleType>>2)&0x01;
	m_bHandleType4 = (struVcaOneRule.struHandleType.dwHandleType>>3)&0x01;
	m_bHandleType5 = (struVcaOneRule.struHandleType.dwHandleType>>4)&0x01;
	ShowAlarmNum(struVcaOneRule, m_dwAlarmOutNum);
	m_listAlarmOut.EnableWindow(m_bHandleType4);
	
	m_comboWeekday.SetCurSel(0);
	m_comboCopyTime.SetCurSel(0);

	memcpy(&m_struAlarmTime[0][0],&struVcaOneRule.struAlarmTime[0][0],
		MAX_DAYS*MAX_TIMESEGMENT_2*sizeof(NET_DVR_SCHEDTIME));
	m_iHour11 = m_struAlarmTime[0][0].byStartHour;
	m_iMin11 = m_struAlarmTime[0][0].byStartMin;
	m_iHour12 = m_struAlarmTime[0][0].byStopHour;
	m_iMin12 = m_struAlarmTime[0][0].byStopMin;
	m_iHour21 = m_struAlarmTime[0][1].byStartHour;
	m_iMin21 = m_struAlarmTime[0][1].byStartMin;
	m_iHour22 = m_struAlarmTime[0][1].byStopHour;
	m_iMin22 = m_struAlarmTime[0][1].byStopMin;
	
	//Setup Filter
	m_bFilterActive = struVcaOneRule.struSizeFilter.byActive;
	GetDlgItem(IDC_CHECK_SET_MAX_FILTER)->EnableWindow(m_bFilterActive);
	GetDlgItem(IDC_CHECK_SET_MINI_FILTER)->EnableWindow(m_bFilterActive);
	
	GetEventParaSet(struVcaOneRule.dwEventType, struVcaOneRule.uEventParam);
	
	//Setup record channel
	F_ShowRecordChan(struVcaOneRule, m_iChannelnumber);
	
	
	UpdateData(FALSE);
	return TRUE;
}

/*********************************************************
Function:	F_ShowRecordChan
Desc:		show recording channel
Input:	NET_VCA_ONE_RULE struVcaOneRule
		int nChanNum
Output:	
Return:	BOOL 
**********************************************************/
BOOL CDlgVcaRuleCfg::F_ShowRecordChan(NET_VCA_ONE_RULE struVcaOneRule, int nChanNum)
{
	m_listRecordChan.SetExtendedStyle(LVS_EX_CHECKBOXES);
	char szLan[128] = {0};
	char sbufCn[128] = {0};
	char sbufEn[128] = {0};
	int i;
	m_listRecordChan.DeleteAllItems();
	for (i = 0; i < nChanNum; i++)
	{
		sprintf(sbufCn, "ͨ%d", (i+1));
		sprintf(sbufEn, "Channel%d", (i+1));
		g_StringLanType(szLan, sbufCn, sbufEn);
		m_listRecordChan.InsertItem(i, szLan);
	}
	
	for (i = 0; i < nChanNum; i++ )
	{
		if (struVcaOneRule.byRelRecordChan[i])
		{
			m_listRecordChan.SetCheck(i);
		}
		
	}
	return TRUE;
}

/*********************************************************
Function:	ShowRuleTypeWnd
Desc:	According to event type, show or Hide correlative control
Input:	VCA_EVENT_TYPE struEventType
Output:	
Return:	 BOOL 
**********************************************************/
BOOL CDlgVcaRuleCfg::ShowRuleTypeWnd(VCA_EVENT_TYPE struEventType)
{
	// Show correlative control and hide others.

	m_staticAlarmDelay.ShowWindow(SW_HIDE);
	m_staticAlarmPersist.ShowWindow(SW_HIDE);
	m_staticMaxDistance.ShowWindow(SW_HIDE);
	m_staticDenstityRate.ShowWindow(SW_HIDE);
	m_staticReadCardTimePersist.ShowWindow(SW_HIDE);

	m_editReadCardTimePersist.ShowWindow(SW_HIDE);
	m_editAlarmDelay.ShowWindow(SW_HIDE);
	m_editDenstityRate.ShowWindow(SW_HIDE);
	m_editMaxDistance.ShowWindow(SW_HIDE);
	m_editAlarmPersist.ShowWindow(SW_HIDE);

	m_staticAlarmDelayArea.ShowWindow(SW_HIDE);
	m_staticAlarmPersistArea.ShowWindow(SW_HIDE);
	m_staticMaxDistanceArea.ShowWindow(SW_HIDE);
	m_staticDenstityRateArea.ShowWindow(SW_HIDE);
	m_staticReadCardTimePersistArea.ShowWindow(SW_HIDE);
	m_staticStickupAlarmPersist.ShowWindow(SW_HIDE);
		
	GetDlgItem(IDC_CHK_DRAW_LINE)->ShowWindow(SW_HIDE);
	m_staticAlarmDirect.ShowWindow(SW_HIDE);
	m_comboAlarmDirect.ShowWindow(SW_HIDE);
	GetDlgItem(IDC_CHK_DRAW_POLYGON)->ShowWindow(SW_HIDE);

	if (struEventType == VCA_TRAVERSE_PLANE)
	{
		GetDlgItem(IDC_CHK_DRAW_LINE)->ShowWindow(SW_SHOW);
		m_staticAlarmDirect.ShowWindow(SW_SHOW);
		m_comboAlarmDirect.ShowWindow(SW_SHOW);
		m_bDrawLine = FALSE;
		m_bDrawPolygon = FALSE;
		memset(&m_struVcaPolygon[m_iCurRuleID], 0, sizeof(NET_VCA_LINE));

	}
	else
	{
		GetDlgItem(IDC_CHK_DRAW_POLYGON)->ShowWindow(SW_SHOW);
		m_bDrawLine = FALSE;
		m_bDrawPolygon = FALSE;
		memset(&m_struVcaLine[m_iCurRuleID], 0, sizeof(NET_VCA_LINE));

		if (struEventType == VCA_ENTER_AREA)
		{
		}
		else if (struEventType == VCA_EXIT_AREA)
		{
		}
		else if (struEventType == VCA_INTRUSION)
		{
			m_staticAlarmDelay.ShowWindow(SW_SHOW);
			m_staticAlarmDelayArea.ShowWindow(SW_SHOW);
			m_editAlarmDelay.ShowWindow(SW_SHOW);
		}
		else if (struEventType == VCA_LOITER)
		{
			m_staticAlarmPersist.ShowWindow(SW_SHOW);
			m_staticAlarmPersistArea.ShowWindow(SW_SHOW);

			m_editAlarmPersist.ShowWindow(SW_SHOW);

		}
		else if (struEventType == VCA_LEFT_TAKE)
		{
			m_staticAlarmPersist.ShowWindow(SW_SHOW);
			m_staticAlarmPersistArea.ShowWindow(SW_SHOW);
			m_editAlarmPersist.ShowWindow(SW_SHOW);
		}
		else if (struEventType == VCA_PARKING)
		{
			m_staticAlarmPersist.ShowWindow(SW_SHOW);
			m_staticAlarmPersistArea.ShowWindow(SW_SHOW);
			m_editAlarmPersist.ShowWindow(SW_SHOW);
		}
		else if (struEventType == VCA_RUN)
		{
			m_staticMaxDistance.ShowWindow(SW_SHOW);
			m_staticMaxDistanceArea.ShowWindow(SW_SHOW);
			m_editMaxDistance.ShowWindow(SW_SHOW);
		}
		else if (struEventType == VCA_HIGH_DENSITY)
		{
			m_staticDenstityRate.ShowWindow(SW_SHOW);
			m_staticDenstityRateArea.ShowWindow(SW_SHOW);
			m_editDenstityRate.ShowWindow(SW_SHOW);
		}
		else if (struEventType == VCA_STICK_UP)
		{
			m_staticStickupAlarmPersist.ShowWindow(SW_SHOW);
			m_staticAlarmPersist.ShowWindow(SW_SHOW);
			m_editAlarmPersist.ShowWindow(SW_SHOW);
		}
		else if (struEventType == VCA_INSTALL_SCANNER)
		{
			m_staticReadCardTimePersist.ShowWindow(SW_SHOW);
			m_staticReadCardTimePersistArea.ShowWindow(SW_SHOW);
			m_editReadCardTimePersist.ShowWindow(SW_SHOW);
		}
		else
		{
			return FALSE;
		}
	}
	return TRUE;	
}

/*********************************************************
Function:	ShowAlarmNum
Desc:	shwo alarm output channel
Input:	NET_VCA_ONE_RULE struVcaOneRule
		int nAlarmNum
Output:	
Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::ShowAlarmNum(NET_VCA_ONE_RULE struVcaOneRule,int nAlarmNum)
{
	m_listAlarmOut.DeleteAllItems();
	m_listAlarmOut.SetExtendedStyle(LVS_EX_CHECKBOXES);
	char szLan[128] = {0};
	char sbufCn[128] = {0};
	char sbufEn[128] = {0};
	int i;
	for (i = 0; i < nAlarmNum; i++)
	{
		sprintf(sbufCn, "%d", (i+1));
		sprintf(sbufEn, "Channel%d", (i+1));
		g_StringLanType(szLan, sbufCn, sbufEn);
		m_listAlarmOut.InsertItem(i, szLan);
	}
	for (i = 0; i < nAlarmNum; i++ )
	{
		if (struVcaOneRule.struHandleType.byRelAlarmOut[i])
		{
			m_listAlarmOut.SetCheck(i);
		}
	}
	
}

/*********************************************************
Function:	GetEventParaSet
Desc:	Get and display Event Parameters
Input:	VCA_EVENT_TYPE struEventType
		NET_VCA_EVENT_UNION uEventParam
Output:	
Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::GetEventParaSet(VCA_EVENT_TYPE struEventType,NET_VCA_EVENT_UNION uEventParam)
{
	BYTE bySensitivity = 0;
	switch (struEventType)
	{
	case VCA_TRAVERSE_PLANE:
		m_comboAlarmDirect.SetCurSel(uEventParam.struTraversePlane.dwCrossDirection);
		OnSelchangeComlinealarmdirect();
		memcpy(&m_struVcaLine[m_iCurRuleID], &uEventParam.struTraversePlane.struPlaneBottom, sizeof(NET_VCA_LINE));
		break;
	case VCA_ENTER_AREA:
		memcpy(&m_struVcaPolygon[m_iCurRuleID], &uEventParam.struArea.struRegion, sizeof(NET_VCA_POLYGON));
		break;
	case VCA_EXIT_AREA:
		memcpy(&m_struVcaPolygon[m_iCurRuleID], &uEventParam.struArea.struRegion, sizeof(NET_VCA_POLYGON));
		break;
	case VCA_INTRUSION:
		memcpy(&m_struVcaPolygon[m_iCurRuleID], &uEventParam.struIntrusion.struRegion, sizeof(NET_VCA_POLYGON));
		m_iAlarmDelay = uEventParam.struIntrusion.wDuration;
		m_staticAlarmDelay.ShowWindow(SW_SHOW);
		m_staticAlarmDelayArea.ShowWindow(SW_SHOW);
		m_editAlarmDelay.ShowWindow(SW_SHOW);
		break;
	case VCA_LOITER:
		memcpy(&m_struVcaPolygon[m_iCurRuleID], &uEventParam.struLoiter.struRegion, sizeof(NET_VCA_POLYGON));
		m_iAlarmPersist	= uEventParam.struLoiter.wDuration;
		m_staticAlarmPersist.ShowWindow(SW_SHOW);
		m_staticAlarmPersistArea.ShowWindow(SW_SHOW);
		m_editAlarmPersist.ShowWindow(SW_SHOW);
		break;
	case VCA_LEFT_TAKE:
		memcpy(&m_struVcaPolygon[m_iCurRuleID], &uEventParam.struTakeTeft.struRegion, sizeof(NET_VCA_POLYGON));
		m_iAlarmPersist	= uEventParam.struTakeTeft.wDuration;
		m_staticAlarmPersist.ShowWindow(SW_SHOW);
		m_staticAlarmPersistArea.ShowWindow(SW_SHOW);
		m_editAlarmPersist.ShowWindow(SW_SHOW);
		break;
	case VCA_PARKING:
		memcpy(&m_struVcaPolygon[m_iCurRuleID], &uEventParam.struParking.struRegion, sizeof(NET_VCA_POLYGON));
		m_iAlarmPersist	= uEventParam.struParking.wDuration;
		m_staticAlarmPersist.ShowWindow(SW_SHOW);
		m_staticAlarmPersistArea.ShowWindow(SW_SHOW);
		m_editAlarmPersist.ShowWindow(SW_SHOW);
		break;
	case VCA_RUN:
		memcpy(&m_struVcaPolygon[m_iCurRuleID], &uEventParam.struRun.struRegion, sizeof(NET_VCA_POLYGON));
		m_fMaxDistance = uEventParam.struRun.fRunDistance;
		m_staticMaxDistance.ShowWindow(SW_SHOW);
		m_staticMaxDistanceArea.ShowWindow(SW_SHOW);
		m_editMaxDistance.ShowWindow(SW_SHOW);
		break;
	case VCA_HIGH_DENSITY:
		memcpy(&m_struVcaPolygon[m_iCurRuleID], &uEventParam.struHighDensity.struRegion, sizeof(NET_VCA_POLYGON));
		m_fDenstityRate = uEventParam.struHighDensity.fDensity;
		m_staticDenstityRate.ShowWindow(SW_SHOW);
		m_staticDenstityRateArea.ShowWindow(SW_SHOW);
		m_editDenstityRate.ShowWindow(SW_SHOW);
		break;
	case VCA_STICK_UP:
		memcpy(&m_struVcaPolygon[m_iCurRuleID], &uEventParam.struStickUp.struRegion, sizeof(NET_VCA_POLYGON));
		m_iAlarmPersist = uEventParam.struStickUp.wDuration;
		m_staticAlarmPersist.ShowWindow(SW_SHOW);
		m_staticStickupAlarmPersist.ShowWindow(SW_SHOW);
		m_editAlarmPersist.ShowWindow(SW_SHOW);
		
		break;
	case VCA_INSTALL_SCANNER:
		memcpy(&m_struVcaPolygon[m_iCurRuleID], &uEventParam.struScanner.struRegion, sizeof(NET_VCA_POLYGON));
		m_iReadCardTimePersist	 = uEventParam.struScanner.wDuration;
		m_staticReadCardTimePersist.ShowWindow(SW_SHOW);
		m_staticReadCardTimePersistArea.ShowWindow(SW_SHOW);
		m_editReadCardTimePersist.ShowWindow(SW_SHOW);
		break;
	default:
		break;
	}
	if (bySensitivity < 1)
	{
		bySensitivity = 0;
	}
	else
	{
		bySensitivity = (unsigned char)(bySensitivity - 1);
	}
	m_comboSensitive.SetCurSel(bySensitivity);
	m_dwPosNum = m_struVcaPolygon[m_iCurRuleID].dwPointNum;
}

/*********************************************************
  Function:	OnCancel
  Desc:		
  Input:	
  Output:	
  Return:	void
**********************************************************/
void CDlgVcaRuleCfg::OnCancel() 
{
	// TODO: Add extra cleanup here
	g_pDlgVcaRuleCfg = NULL;
	if (m_lPlayHandle >= 0)
	{
		NET_DVR_StopRealPlay(m_lPlayHandle);
		m_lPlayHandle = -1;
	}
	else 
	{
	
	}
	CDialog::OnCancel();
}

/*********************************************************
Function:	SetVcaDrawMode
Desc:		Add Target
Input:	
Output:	
Return: void 	
**********************************************************/
void CDlgVcaRuleCfg::SetVcaDrawMode()
{
	UpdateData(TRUE);
	m_struVCADrawMode.byDspAddRule = (unsigned char)m_bDSPAddRule;
	m_struVCADrawMode.byDspAddTarget = (unsigned char)m_bDSPAddTarget;
	m_struVCADrawMode.byDspPicAddRule = (unsigned char)m_bPicAddRule;
	m_struVCADrawMode.byDspPicAddTarget = (unsigned char)m_bPicAddTarget;
	char szLan[128] = {0};
	if (!NET_DVR_SetVCADrawMode(m_lServerID,  m_iVcaChannel, &m_struVCADrawMode))
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_VCA_DRAW_MODE %d", m_iVcaChannel);
		char sbufCn[128] = {0};
		char sbufEn[128] = {0};
		sprintf(sbufCn,"ͨ%dĿʧ", m_iVcaChannel);
		sprintf(sbufEn, "Set target added for channel%d failed");
		g_StringLanType(szLan, sbufCn, sbufEn);
		AfxMessageBox(szLan);
	}
	else
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_VCA_DRAW_MODE %d", m_iVcaChannel);
		char sbufCn[128] = {0};
		char sbufEn[128] = {0};
		sprintf(sbufCn,"ͨ%dĿӳɹ", m_iVcaChannel);
		sprintf(sbufEn, "Set target added for channel%d successfully");
		g_StringLanType(szLan, sbufCn, sbufEn);
		AfxMessageBox(szLan);
	}
}

/*********************************************************
  Function:	OnChkRuleActive
  Desc:		Invalid or not
  Input:	
  Output:	
  Return:	void
**********************************************************/ 
void CDlgVcaRuleCfg::OnChkRuleActive() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	EnableRuleWindow(m_bRuleActive);
	m_struOneRule.byActive = (unsigned char)m_bRuleActive;
	UpdateData(FALSE);
	OnSelchangeComboRuleType();
}

/*********************************************************
Function:	EnableRuleWindow
Desc:	    
Input:	BOOL bEnable
Output:	
Return:	BOOL
**********************************************************/
BOOL CDlgVcaRuleCfg::EnableRuleWindow(BOOL bEnable)
{
	GetDlgItem(IDC_COMBO_RULE_TYPE)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_RULE_NAME)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECK_FILTER_ACTIVE)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECK_SET_MINI_FILTER)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHK_DRAW_POLYGON)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECK_SET_MAX_FILTER)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBO_SENSITIVE)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_ALARM_DELAY)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_ALARM_PERSIST)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECKHANDLETYPE1)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECKHANDLETYPE2)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECKHANDLETYPE3)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECKHANDLETYPE4)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITHOUR11)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITMIN11)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITHOUR12)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITMIN12)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITHOUR21)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITMIN21)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITHOUR22)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDITMIN22)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBOWEEKDAY)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMBOCOPYTIME)->EnableWindow(bEnable);
	GetDlgItem(IDC_TIME_COPY)->EnableWindow(bEnable);
	GetDlgItem(IDC_TIME_OK)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECKHANDLETYPE5)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_MAX_DISTANCE)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_DENSTITY_RATE)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_READ_CARD_TIME_PERSIST)->EnableWindow(bEnable);
	GetDlgItem(IDC_LIST_RECORD_CHAN)->EnableWindow(bEnable);
	GetDlgItem(IDC_STATIC_ALARM_DIRECT)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMLINEALARMDIRECT)->EnableWindow(bEnable);
	GetDlgItem(IDC_LIST_ALARM_OUT)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHK_DRAW_LINE)->EnableWindow(bEnable);

	return TRUE;
}

/*********************************************************
  Function:	OnSelchangeComboRuleType
  Desc:		Modify Rule Type 
  Input:	
  Output:	
  Return:	void
**********************************************************/
void CDlgVcaRuleCfg::OnSelchangeComboRuleType() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	VCA_EVENT_TYPE struEventType;

	struEventType = GetEventType(m_comboRuleType.GetCurSel());
	ShowRuleTypeWnd(struEventType);
	if (struEventType == m_struRuleCfg.struRule[m_iCurRuleID].dwEventType)
	{

		GetEventParaSet(struEventType, m_struRuleCfg.struRule[m_iCurRuleID].uEventParam);
	}
	else
	{
		NET_VCA_EVENT_UNION uEventParam;
		memset(&uEventParam, 0, sizeof(NET_VCA_EVENT_UNION));
		GetEventParaSet(struEventType, uEventParam);
	}
	m_struOneRule.dwEventType = struEventType; 
	UpdateData(FALSE);
}


/*********************************************************
Function:	GetEventType
Desc:	
Input:	int num
Output:	
Return:	VCA_EVENT_TYPE
**********************************************************/
VCA_EVENT_TYPE CDlgVcaRuleCfg::GetEventType(int num)
{
	return (VCA_EVENT_TYPE)m_comboRuleType.GetItemData(num);
}

/*********************************************************
Function:	F_DrawFun
Desc:		Draw
Input:	lPlayHandle, player handle
		hDc : DC handle
		dwUser: User data to distinguish different channels
Output:	
Return:	void
**********************************************************/
void CDlgVcaRuleCfg::F_DrawFun(long lPlayHandle, HDC hDc, DWORD dwUser)
{
	COLORREF color;
	color = RGB(255, 255, 0);//Yellow
	if(	m_struOneRule.dwEventType== VCA_ENTER_AREA
		|| m_struOneRule.dwEventType == VCA_EXIT_AREA
		|| m_struOneRule.dwEventType == VCA_INTRUSION
		|| m_struOneRule.dwEventType == VCA_LOITER
		|| m_struOneRule.dwEventType == VCA_LEFT_TAKE
		|| m_struOneRule.dwEventType == VCA_PARKING
		|| m_struOneRule.dwEventType == VCA_RUN
		|| m_struOneRule.dwEventType == VCA_HIGH_DENSITY
		|| m_struOneRule.dwEventType == VCA_STICK_UP
		|| m_struOneRule.dwEventType == VCA_INSTALL_SCANNER
		)
	{
		F_DrawFrame(lPlayHandle, hDc, dwUser, m_iCurRuleID, color);
	}
	else if (m_struOneRule.dwEventType == VCA_TRAVERSE_PLANE)
	{
		F_DrawLine(lPlayHandle, hDc, dwUser, m_iCurRuleID, color);
	}
	
	F_DrawFilter(lPlayHandle, hDc, dwUser, m_iCurRuleID, RGB(0, 255, 125));
}

/*********************************************************
Function:	F_DrawFrame
Desc:	
Input:	lPlayHandle, Player handle
		hDc : DC handle
		dwUser: User data to distinguish different channels
		DWORD dwRuleID :current rule ID
		COLORREF color:color of line
Output:	
Return:	 void
**********************************************************/
void CDlgVcaRuleCfg::F_DrawFrame(long lRealHandle, HDC hDc, DWORD dwUser, DWORD dwRuleID, COLORREF color)
{
	UNREFERENCED_PARAMETER(dwUser);
	UNREFERENCED_PARAMETER(lRealHandle);

    using namespace Gdiplus;
    Graphics graphics(hDc);
    SolidBrush  brush(Color(50, 0, 0, 0));
    brush.SetColor(Color(50, GetRValue(color), GetGValue(color), GetBValue(color)));
    
    POINT point[VCA_MAX_POLYGON_POINT_NUM] = {0};
    
	CPen DrawPen;
	unsigned int i;
	
	DrawPen.CreatePen(PS_SOLID, 1, color);
	SetTextColor(hDc,color);
	
	HGDIOBJ pOldPen = SelectObject(hDc, DrawPen);
	MoveToEx(hDc, (int)(m_struVcaPolygon[dwRuleID].struPos[0].fX*m_rcWndRect.Width()), \
		(int)(m_struVcaPolygon[dwRuleID].struPos[0].fY*m_rcWndRect.Height()), NULL);
	
	for(i=1; i<m_struVcaPolygon[dwRuleID].dwPointNum; i++)
	{
        
		LineTo(hDc, (int)(m_struVcaPolygon[dwRuleID].struPos[i].fX*m_rcWndRect.Width()),\
			(int)(m_struVcaPolygon[dwRuleID].struPos[i].fY*m_rcWndRect.Height()));
		//Redraw the polygon if the lines are intersectant.
		if(i>=MIN_PNT_NUM && !m_bMouseMove[m_iCurRuleID] && IsCrossLine(&m_struVcaPolygon[dwRuleID]))
		{
			char szLan[128] = {0};
			g_StringLanType(szLan,"βڵıཻ,!","Edges of Polygon can be intersectant, please redraw.!");
			AfxMessageBox(szLan);
			m_dwPosNum--;
			m_struVcaPolygon[dwRuleID].dwPointNum--;
			break;
		}
		if(!m_bCloseIn[dwRuleID])
		{
			m_bDrawPolygon = TRUE;
		}
	}
    
    for (i=0; i<(int)m_struVcaPolygon[dwRuleID].dwPointNum ; i++)
    {
        if (i == VCA_MAX_POLYGON_POINT_NUM)
        {
            break;
        }
        
        point[i].x = (int)(m_struVcaPolygon[dwRuleID].struPos[i].fX*m_rcWndRect.Width());
        point[i].y = (int)(m_struVcaPolygon[dwRuleID].struPos[i].fY*m_rcWndRect.Height());
    }
	//After drawing the 10th point, connect it with the 1st point.
	if(VCA_MAX_POLYGON_POINT_NUM == i && !m_bMouseMove[m_iCurRuleID])
	{
		if (IsValidArea(&m_struVcaPolygon[dwRuleID]))
		{
            graphics.FillPolygon(&brush, (Point *)point, m_struVcaPolygon[dwRuleID].dwPointNum);
            
			LineTo(hDc, (int)(m_struVcaPolygon[dwRuleID].struPos[0].fX*m_rcWndRect.Width()), (int)(m_struVcaPolygon[dwRuleID].struPos[0].fY*m_rcWndRect.Height()));	
			F_AddLabel(hDc, AlarmArea, dwRuleID);//
			m_bCloseIn[dwRuleID] = TRUE;
		}else//redraw
		{
			m_bCloseIn[dwRuleID] = FALSE;
			m_bNeedRedraw[dwRuleID] = TRUE;
			m_struVcaPolygon[dwRuleID].dwPointNum--;
			m_dwPosNum--;
		}
		//check if the alarm region is intact
	}
	else if(m_struVcaPolygon[dwRuleID].dwPointNum>2 && m_bCloseIn[dwRuleID])
	{
		if (IsValidArea(&m_struVcaPolygon[dwRuleID]))
		{
            graphics.FillPolygon(&brush, (Point *)point, m_struVcaPolygon[dwRuleID].dwPointNum);
            
			LineTo(hDc, (int)(m_struVcaPolygon[dwRuleID].struPos[0].fX*m_rcWndRect.Width()),(int)(m_struVcaPolygon[dwRuleID].struPos[0].fY*m_rcWndRect.Height()));
			F_AddLabel(hDc, AlarmArea, dwRuleID);
		}else
		{
			m_bNeedRedraw[dwRuleID] = TRUE;
			m_bCloseIn[dwRuleID] = FALSE;
		}
	}
	
	SelectObject(hDc, pOldPen);
	DeleteObject(DrawPen);
}

/*********************************************************
Function:	F_DrawFilter
Desc:	Rule filter
Input:	lPlayHandle, Player handle
		hDc :DC handle
		dwUser: User data
		DWORD dwRuleID Current rule ID
		COLORREF color 
Output:	
Return:	 void
**********************************************************/
void CDlgVcaRuleCfg::F_DrawFilter(long lRealHandle, HDC hDc, DWORD dwUser, DWORD dwRuleID, COLORREF color)
{
	UNREFERENCED_PARAMETER(dwRuleID);
	UNREFERENCED_PARAMETER(dwUser);
	UNREFERENCED_PARAMETER(lRealHandle);
//	if (m_bSetMiniFilter || m_bSetMaxFilter)
	if (m_bFilterActive)
	{
		CPen DrawPen;
		
		DrawPen.CreatePen(PS_SOLID, 1, color);
		CBrush brTmp;
		brTmp.CreateSolidBrush(color);
		
		HGDIOBJ pOldPen = SelectObject(hDc, DrawPen);
		CRect rectMini, rectMax;
		rectMini.left = (int)(m_struOneRule.struSizeFilter.struMiniRect.fX*m_rcWndRect.Width());
		rectMini.top = (int)(m_struOneRule.struSizeFilter.struMiniRect.fY*m_rcWndRect.Height());
		rectMini.right = (int)((m_struOneRule.struSizeFilter.struMiniRect.fX+m_struOneRule.struSizeFilter.struMiniRect.fWidth)*m_rcWndRect.Width());
		rectMini.bottom = (int)((m_struOneRule.struSizeFilter.struMiniRect.fY+m_struOneRule.struSizeFilter.struMiniRect.fHeight)*m_rcWndRect.Height());
		FrameRect(hDc, rectMini, brTmp);
		
		rectMax.left = (int)(m_struOneRule.struSizeFilter.struMaxRect.fX*m_rcWndRect.Width());
		rectMax.top = (int)(m_struOneRule.struSizeFilter.struMaxRect.fY*m_rcWndRect.Height());
		rectMax.right = (int)((m_struOneRule.struSizeFilter.struMaxRect.fX+m_struOneRule.struSizeFilter.struMaxRect.fWidth)*m_rcWndRect.Width());
		rectMax.bottom = (int)((m_struOneRule.struSizeFilter.struMaxRect.fY+m_struOneRule.struSizeFilter.struMaxRect.fHeight)*m_rcWndRect.Height());
		FrameRect(hDc, rectMax, brTmp);
		
		SelectObject(hDc, pOldPen);
		DeleteObject(DrawPen);
	}
}

/*********************************************************
Function:	F_AddLabel
Desc:		Add Label on player window
Input:	hDc : DC handle
		iAlarmType: Alarm Type
		dwRuleID: Current rule ID
Output:	
Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::F_AddLabel(HDC hDc, int iAlarmType, DWORD dwRuleID)
{
	if (AlarmArea == iAlarmType)
	{
		CString szTemp(_T(""));
		DWORD dwID;
		dwID = 0;
		CRect rect;
		UINT uFormat = DT_LEFT;
		int iTxtWidth = 0;// width of label
		int iTxtHeight = 20;//height of label	
		iTxtWidth = iTxtHeight;
		szTemp.Format("(%d)", dwRuleID);
		
		if (m_struVcaPolygon[dwRuleID].struPos[0].fX >= 0.5 && m_struVcaPolygon[dwRuleID].struPos[0].fY >= 0.5)
		{
			uFormat = DT_RIGHT;
			rect.left = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fX*m_rcWndRect.Width()) - iTxtWidth;
			rect.top = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fY*m_rcWndRect.Height()) - iTxtHeight;
			rect.bottom = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fY*m_rcWndRect.Height());
			rect.right = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fX*m_rcWndRect.Width());
		}else if (m_struVcaPolygon[dwRuleID].struPos[0].fX < 0.5 && m_struVcaPolygon[dwRuleID].struPos[0].fY < 0.5)
		{
			uFormat = DT_LEFT;
			rect.left = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fX*m_rcWndRect.Width());
			rect.top = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fY*m_rcWndRect.Height());
			rect.bottom = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fY*m_rcWndRect.Height()) + iTxtHeight;
			rect.right = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fX*m_rcWndRect.Width()) + iTxtWidth;
		}else if (m_struVcaPolygon[dwRuleID].struPos[0].fX < 0.5 && m_struVcaPolygon[dwRuleID].struPos[0].fY >= 0.5)
		{
			uFormat = DT_LEFT;
			rect.left = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fX*m_rcWndRect.Width());
			rect.top = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fY*m_rcWndRect.Height()) - iTxtHeight;
			rect.bottom = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fY*m_rcWndRect.Height());
			rect.right = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fX*m_rcWndRect.Width()) + iTxtWidth;
			
		}else if (m_struVcaPolygon[dwRuleID].struPos[0].fX >= 0.5 && m_struVcaPolygon[dwRuleID].struPos[0].fY < 0.5)
		{
			uFormat = DT_RIGHT;
			rect.left = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fX*m_rcWndRect.Width()) - iTxtWidth;
			rect.top = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fY*m_rcWndRect.Height());
			rect.bottom = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fY*m_rcWndRect.Height()) + iTxtHeight;
			rect.right = (int)(m_struVcaPolygon[dwRuleID].struPos[0].fX*m_rcWndRect.Width());
		}
		DrawText(hDc, szTemp, strlen(szTemp), &rect, uFormat);

	}
	if (iAlarmType == AlarmLine)
	{
		CString szTemp(_T(""));
		DWORD dwID;
		dwID = 0;
		CRect rect;
		UINT uFormat = DT_LEFT;
		int iTxtWidth = 0;
		int iTxtHeight = 20;
		iTxtWidth = iTxtHeight;
		szTemp.Format("(%d)", dwRuleID);
		
		if (m_struVcaLine[dwRuleID].struStart.fX >= 0.5 && m_struVcaLine[dwRuleID].struStart.fY >= 0.5)
		{//Alarm Plane at right bottom
			uFormat = DT_RIGHT;
			rect.left = (int)(m_struVcaLine[dwRuleID].struStart.fX*m_rcWndRect.Width()) - iTxtWidth;
			rect.top = (int)(m_struVcaLine[dwRuleID].struStart.fY*m_rcWndRect.Height()) - iTxtHeight;
			rect.bottom = (int)(m_struVcaLine[dwRuleID].struStart.fY*m_rcWndRect.Height());
			rect.right = (int)(m_struVcaLine[dwRuleID].struStart.fX*m_rcWndRect.Width());
		}
		else if (m_struVcaLine[dwRuleID].struStart.fX < 0.5 && m_struVcaLine[dwRuleID].struStart.fY < 0.5)
		{//Alarm Plane at left top
			uFormat = DT_LEFT;
			rect.left = (int)(m_struVcaLine[dwRuleID].struStart.fX*m_rcWndRect.Width());
			rect.top = (int)(m_struVcaLine[dwRuleID].struStart.fY*m_rcWndRect.Height());
			rect.bottom = (int)(m_struVcaLine[dwRuleID].struStart.fY*m_rcWndRect.Height()) + iTxtHeight;
			rect.right = (int)(m_struVcaLine[dwRuleID].struStart.fX*m_rcWndRect.Width()) + iTxtWidth;
		}
		else if (m_struVcaLine[dwRuleID].struStart.fX < 0.5 && m_struVcaLine[dwRuleID].struStart.fY >= 0.5)
		{//Alarm Plane at left bottom
			uFormat = DT_LEFT;
			rect.left = (int)(m_struVcaLine[dwRuleID].struStart.fX*m_rcWndRect.Width());
			rect.top = (int)(m_struVcaLine[dwRuleID].struStart.fY*m_rcWndRect.Height()) - iTxtHeight;
			rect.bottom = (int)(m_struVcaLine[dwRuleID].struStart.fY*m_rcWndRect.Height());
			rect.right = (int)(m_struVcaLine[dwRuleID].struStart.fX*m_rcWndRect.Width()) + iTxtWidth;
		}
		else if (m_struVcaLine[dwRuleID].struStart.fX >= 0.5 && m_struVcaLine[dwRuleID].struStart.fY < 0.5)
		{
			//Alarm Plane at right bottom
			uFormat = DT_RIGHT;
			rect.left = (int)(m_struVcaLine[dwRuleID].struStart.fX*m_rcWndRect.Width()) - iTxtWidth;
			rect.top = (int)(m_struVcaLine[dwRuleID].struStart.fY*m_rcWndRect.Height());
			rect.bottom = (int)(m_struVcaLine[dwRuleID].struStart.fY*m_rcWndRect.Height()) + iTxtHeight;
			rect.right = (int)(m_struVcaLine[dwRuleID].struStart.fX*m_rcWndRect.Width());
		}
		DrawText(hDc, szTemp, strlen(szTemp), &rect, uFormat);
	}
}

/*********************************************************
Function:	IsValidArea
Desc:		Check if the area is valid
Input:	alarm_region: 
Output:	
Return:	BOOL
**********************************************************/
BOOL CDlgVcaRuleCfg::IsValidArea(NET_VCA_POLYGON *alarm_region)
{
	if(alarm_region == NULL)
	{
		return FALSE;
	}
	// Check if all points of polygon is in one line.
	if (F_IsStraightLine(alarm_region))
	{
		char szLan[128] = {0};
		g_StringLanType(szLan, "еͬһֱϣɶ!",\
			"All points have been in the same line, not able to form the polygon");
		MessageBox(szLan);
		return FALSE;
	}
	// жɶεյеֱǷн
	if (F_IsACrossLine(alarm_region))
	{
		char szLan[128] = {0};
		g_StringLanType(szLan,"յеֱཻЧĶ!", \
			"The edges of polygon can't be intersectant, please draw again");
		MessageBox(szLan);
		return FALSE;
	}
	return TRUE;
}

/*********************************************************
Function:	IsCrossLine
Desc:	IsCrossLine
Input:	
Output:	
Return:	BOOL 
**********************************************************/
BOOL CDlgVcaRuleCfg::IsCrossLine(NET_VCA_POLYGON *alarm_region)
{
	if(alarm_region == NULL)
	{
		return FALSE;
	}
	unsigned int i, j;
	DWORD nPointTotal = 0;
	NET_VCA_POINT *pPointArray = NULL;
	NET_VCA_POINT *pPntArr = NULL;
	BOOL    bCrossLine;
	
	pPointArray = alarm_region->struPos;
	nPointTotal = alarm_region->dwPointNum;
	bCrossLine  = FALSE;
	
	// The apexes of polygon should be more than 3
	if (nPointTotal >= 3)
	{
		bCrossLine = FALSE;
	}
	else
	{
		pPntArr = new NET_VCA_POINT[nPointTotal];
		if (pPntArr == NULL)
		{
			char szLan[128] = {0};
			g_StringLanType(szLan, "ڴʧ!","Allocate memory failed!");
			AfxMessageBox(szLan);
			exit(EXIT_FAILURE);
		}
		
		//Copy the apex to a array
		for (i = 0; i < nPointTotal; i++)
		{
			pPntArr[i] = pPointArray[i];
		}
		
		for(i = 0; i < nPointTotal - 3; i++)
		{
			for (j = i + 2; j < nPointTotal-1; j++)
			{
				
				if (F_LineCrossDetect(pPntArr[i], pPntArr[i + 1], pPntArr[j], pPntArr[j + 1]))
				{
					bCrossLine = TRUE;
				}			
			}
		}
		if (pPntArr != NULL)
		{
			delete [] pPntArr;
		}
	}
	return bCrossLine;
}

/*********************************************************
Function:	F_IsACrossLine
Desc:		Check if cross the alarm plane
Input:	NET_VCA_POLYGON *alarm_region
Output:	
Return:	BOOL 
**********************************************************/
BOOL CDlgVcaRuleCfg::F_IsACrossLine(NET_VCA_POLYGON *alarm_region)
{
	if(alarm_region == NULL)
	{
		return FALSE;
	}
	unsigned int i;
	DWORD	 nPointTotal;
	NET_VCA_POINT *pPointArray;
	NET_VCA_POINT *pPntArr;
	BOOL    bCrossLine;
	
	pPointArray = alarm_region->struPos;
	nPointTotal = alarm_region->dwPointNum;
	bCrossLine  = FALSE;
	
	
	if (nPointTotal == VCA_MAX_POLYGON_POINT_NUM)
	{
		bCrossLine = FALSE;
	}
	else
	{
		pPntArr = new NET_VCA_POINT[nPointTotal];
		if (pPntArr == NULL)
		{
			char szLan[128] = {0};
			g_StringLanType(szLan, "Allocate memory failed!","Memory allocation failure!");
			AfxMessageBox(szLan);
			exit(EXIT_FAILURE);
		}
		
		for (i = 0; i < nPointTotal; i++)
		{
			pPntArr[i] = pPointArray[i];
		}
		//      pPntArr[nPointTotal] = pPointArray[0];
		
		for(i = 0; i < nPointTotal - 1; i++)
		{
			
			if (F_LineCrossDetect(pPntArr[0], pPntArr[nPointTotal - 1], pPntArr[i], pPntArr[i + 1]))
			{
				bCrossLine = TRUE;
			}			
		} 
		delete [] pPntArr;
	}
	return bCrossLine;
}

/*********************************************************
Function:	F_IsStraightLine
Desc:	
Input:	NET_VCA_POLYGON *alarm_region
Output:	
Return:	BOOL 
**********************************************************/
BOOL CDlgVcaRuleCfg::F_IsStraightLine(NET_VCA_POLYGON *alarm_region)
{
	if(alarm_region == NULL)
	{
		return FALSE;
	}
	unsigned int i = 0;
	BOOL         bStraightLine;
	float        fSlope;
	float        fDistance;
	float        fCoefficient;
	float        fOffset;
	DWORD		 nPointTotal;
	NET_VCA_POINT *pPointArray;
	int          nXOffset;
	int          nYOffset;
	
	pPointArray = alarm_region->struPos;
	nPointTotal = alarm_region->dwPointNum;
	
	nXOffset = (int)(pPointArray[0].fX - pPointArray[1].fX);
	nYOffset = (int)(pPointArray[0].fY - pPointArray[1].fY);
	bStraightLine = TRUE;
	
	//Check if all points construct a vertical line.
	if (0 == nXOffset)
	{
		for (i = 2; i < nPointTotal; i++)
		{
			if (pPointArray[0].fX != pPointArray[i].fX)
			{
				bStraightLine = FALSE;
				break;
			}
		}
	}
	
	// Check if all points construct a horizontal line.
	if (0 == nYOffset)
	{
		for (i = 2; i < nPointTotal; i++)
		{
			if (pPointArray[0].fY != pPointArray[i].fY)
			{
				bStraightLine = FALSE;
				break;
			}                 
		}
	}
	
	// Check if all points construct a diagonal.
	if ((0 != nXOffset) && (0 != nYOffset))
	{
		// calculate slope
		fSlope  = 1.0f * nYOffset / nXOffset;
		// intercept 
		fOffset = pPointArray[0].fY - fSlope * pPointArray[1].fX;
		// the coefficient for calculating the distance between point and line. 
		fCoefficient = (float)sqrt(1.0 + fSlope * fSlope);
		
		for (i = 2; i < nPointTotal; i ++)
		{
			// Calculate the distance between other point and the line constructed by point 1 and point 2. 
			fDistance = (float)fabs(fSlope * pPointArray[i].fX - pPointArray[i].fY + fOffset)/fCoefficient;
			
			// if there is one distance of points that is more than 0, the polygon is valid.
			if ((fDistance - 0.0f) > 0.000001f)
			{
				bStraightLine = FALSE;
				break;
			}
		}		
	}
	
	return bStraightLine;	
}


/*********************************************************
Function:	F_LineCrossDetect
Desc:	
Input:	NET_VCA_POINT p1
		NET_VCA_POINT p2
		NET_VCA_POINT q1
		NET_VCA_POINT q1
Output:	
Return:	BOOL 
**********************************************************/
BOOL CDlgVcaRuleCfg::F_LineCrossDetect(NET_VCA_POINT p1, NET_VCA_POINT p2, NET_VCA_POINT q1, NET_VCA_POINT q2)
{
	NET_VCA_POINT p1_q1, q2_q1, p2_q1, q1_p1, p2_p1, q2_p1;       //Difference vector
	float z1, z2, z3, z4;
	BOOL  line_cross = FALSE;
	
	// p1 - q1;
	p1_q1.fX = p1.fX - q1.fX;
	p1_q1.fY = p1.fY - q1.fY;
	
	// q2 - q1;
	q2_q1.fX = q2.fX - q1.fX;
	q2_q1.fY = q2.fY - q1.fY;
	
	// p2 - q1;
	p2_q1.fX = p2.fX - q1.fX;
	p2_q1.fY = p2.fY - q1.fY;
	
	// 1 (p1 - q1)  (q2 - q1)
	z1 = p1_q1.fX * q2_q1.fY - q2_q1.fX * p1_q1.fY; 
	
	// 2 (q2 - q1)  (p2 - q1)
	z2 = q2_q1.fX * p2_q1.fY - p2_q1.fX * q2_q1.fY;
	
	// q1 - p1;
	q1_p1.fX = q1.fX - p1.fX;
	q1_p1.fY = q1.fY - p1.fY;
	
	// p2 - p1;
	p2_p1.fX = p2.fX - p1.fX;
	p2_p1.fY = p2.fY - p1.fY;
	
	// q2 - p1;
	q2_p1.fX = q2.fX - p1.fX;
	q2_p1.fY = q2.fY - p1.fY;
	
	// 3 (q1 - p1)  (p2 - p1)
	z3 = q1_p1.fX * p2_p1.fY - p2_p1.fX * q1_p1.fY;
	
	//4 (p2 - p1)  (q2 - p1);
	z4 = p2_p1.fX * q2_p1.fY - q2_p1.fX * p2_p1.fY;
	
	
	//  check the span of two segment
	if( ((z1 >= 0.0f && z2 >= 0.0f) || (z1 < 0.0f && z2 < 0.0f)) && 
		((z3 >= 0.0f && z4 >= 0.0f) || (z3 < 0.0f && z4 < 0.0f)))
	{
		line_cross = TRUE;	
	}else
	{
		line_cross = FALSE;
	}
	
	return line_cross;
}

/*********************************************************
Function:	F_DrawLine
Desc:	
Input:	long lPlayHandle
		HDC hDc
		DWORD dwUser
		DWORD dwRuleID
		COLORREF color
Output:	
Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::F_DrawLine(long lPlayHandle, HDC hDc, DWORD dwUser, DWORD dwRuleID, COLORREF color)
{
	UNREFERENCED_PARAMETER(dwUser);
	UNREFERENCED_PARAMETER(lPlayHandle);
    
	int iDirect = -1;
    int x1 = (int)(m_struVcaLine[dwRuleID].struStart.fX*m_rcWndRect.Width());
    int y1 = (int)(m_struVcaLine[dwRuleID].struStart.fY*m_rcWndRect.Height());
    int x2 = (int)(m_struVcaLine[dwRuleID].struEnd.fX*m_rcWndRect.Width());
    int y2 = (int)(m_struVcaLine[dwRuleID].struEnd.fY*m_rcWndRect.Height());
	
	SetTextColor(hDc,color);
	
    using namespace Gdiplus;
    Graphics graphics(hDc);
    Color DrawColor;
    DrawColor.SetValue(DrawColor.MakeARGB(50,GetRValue(color) ,GetGValue(color),GetBValue(color)));
    
    Pen pen(color, 4);
    pen.SetStartCap(LineCapFlat);
    pen.SetEndCap(LineCapFlat);
    
    CPen DrawPen;
    DrawPen.CreatePen(PS_SOLID, 1, color);
    
    bool bRect = false;
    int k = 0;
    //calculate slope
    if(x2 != x1)
	{
        k = (y2 - y1) / (x2 - x1);
		
        //if the absolute value of slope is more than 2, draw rectangle directly
        if(abs(k) >= 2)
        {
            bRect = true;
        }
    }
    else
    {
        bRect = true;
    }
		
    if(bRect)
		{
        TRACE("Line\n");
        
        pen.SetColor(DrawColor);
        if(k < 0)
        {
            graphics.DrawLine(&pen, x1-2, y1-1, x2-2, y2-1);
        }
        else
        {
            graphics.DrawLine(&pen, x1+2, y1-1, x2+2, y2-1);
        }
    }
    else
    {
        //Draw parallelogram, the vertical height is 8
        SolidBrush  brush(DrawColor);
        POINT point[4];
        point[0].x = x1;
        point[0].y = y1;
        point[1].x = x2;
        point[1].y = y2;
        point[2].x = x2;
        point[2].y = y2-8;
        point[3].x = x1;
        point[3].y = y1-8;
        graphics.FillPolygon(&brush, (Point *)point, 4);
		}
		
    
    HGDIOBJ pOldPen = SelectObject(hDc, DrawPen);
    MoveToEx(hDc, x1, y1, NULL);
    LineTo(hDc, x2, y2);
    
		//Draw arrow
    F_DrawArrowhead(hDc, dwRuleID, m_struOneRule.uEventParam.struTraversePlane.dwCrossDirection);
		//Draw label
		F_AddLabel(hDc, AlarmLine, dwRuleID);
    
	SelectObject(hDc, pOldPen);
	DeleteObject(DrawPen);
}

/*********************************************************
Function:	F_DrawArrowhead
Desc:		Draw Arrow. 
Input:	HDC hDc
		DWORD dwRuleID
		int direction
Output:	
Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::F_DrawArrowhead(HDC hDc, DWORD dwRuleID, int direction)
{
    POINT ptArrow_start0;/*, ptArrow_start1, ptArrow_start2;*/
    POINT ptArrow_end;
    float fLine_k = 0.0, fArrow_k = 0.0, fArrow_k1 = 0.0;
    int   iTheta = 0;
    int   iDirection = -1;
    //check the direction of flyover line
    switch(direction)
    {
    case VCA_LEFT_GO_RIGHT:
        iDirection = 0;
        break;
    case VCA_RIGHT_GO_LEFT:
        iDirection = 1;
        break;
    case VCA_BOTH_DIRECTION:
        iDirection = 2;
        break;
    }

    //Draw arrow
    //coordinate of arrow's end
    ptArrow_start0.x = (long)(m_rcWndRect.Width()*(m_struVcaLine[dwRuleID].struStart.fX+m_struVcaLine[dwRuleID].struEnd.fX) / 2);
    ptArrow_start0.y = (long)(m_rcWndRect.Height()*(m_struVcaLine[dwRuleID].struStart.fY + m_struVcaLine[dwRuleID].struEnd.fY) / 2);

    //slope
    fLine_k = (m_struVcaLine[dwRuleID].struEnd.fY*m_rcWndRect.Height() - m_struVcaLine[dwRuleID].struStart.fY*m_rcWndRect.Height()) / 
        (m_struVcaLine[dwRuleID].struEnd.fX*m_rcWndRect.Width() - m_struVcaLine[dwRuleID].struStart.fX*m_rcWndRect.Width());

    POINT ptStart0;

    using namespace Gdiplus;
    Graphics graphics(hDc);

    Color color(80, 0, 0, 0);
    color.SetValue(color.MakeARGB(80,255,255,0));

    Pen pen(color, 5);
    //if the absolute value of slope is more than 2, the width of arrow is 4
    if(abs(fLine_k) >= 2)
		{
        pen.SetWidth(4);
    }
    else
    {
        //otherwise the width of arrow is 8*cos(alpha)
        float fWidth = 8.0 / sqrt(1.0 + fLine_k * fLine_k);
        pen.SetWidth(fWidth);
    }

    pen.SetStartCap(LineCapFlat);
    pen.SetEndCap(LineCapArrowAnchor);

    if (fLine_k != 0.0)
    {
        TRACE("draw\n");
        //perpendicular segment on the line
        fArrow_k =  -1.0 / fLine_k;

        iTheta = (int)(atan(fArrow_k ) / PI * 180);

        if (0 == iDirection || 2 == iDirection)
        {
            //reduce 1 of width to prevent the arrow deviate from the segment
            if(fLine_k > 0)
            {
                ptStart0.x = ptArrow_start0.x - (8-1) * sin(iTheta / 180.0 * PI) * cos(iTheta / 180.0 * PI);
                ptStart0.y = ptArrow_start0.y - (8-1) * sin(iTheta / 180.0 * PI) * sin(iTheta / 180.0 * PI);
		}
            else
		{
                ptStart0.x = ptArrow_start0.x;
                ptStart0.y = ptArrow_start0.y;
            }

            ptArrow_end.x = ptStart0.x + 20 * cos(iTheta / 180.0 * PI);
            ptArrow_end.y = 20 * sin(iTheta / 180.0 * PI) + ptStart0.y;

            graphics.DrawLine(&pen, ptStart0.x, ptStart0.y, ptArrow_end.x, ptArrow_end.y);
        }

        if (1 == iDirection || 2 == iDirection)
        {
            if(fLine_k > 0)
            {
                ptStart0.x = ptArrow_start0.x;
                ptStart0.y = ptArrow_start0.y;
            }
            else
            {
                ptStart0.x = ptArrow_start0.x - (8-1) * sin(iTheta / 180.0 * PI) * cos(iTheta / 180.0 * PI);
                ptStart0.y = ptArrow_start0.y - (8-1) * sin(iTheta / 180.0 * PI) * sin(iTheta / 180.0 * PI);
            }

            ptArrow_end.x = ptStart0.x - 20 * cos(iTheta / 180.0 * PI);
            ptArrow_end.y = (-20) * sin(iTheta / 180.0 * PI) + ptStart0.y ;

            graphics.DrawLine(&pen, ptStart0.x, ptStart0.y, ptArrow_end.x, ptArrow_end.y);
		}
	}else
	{
        //The arrow is vertical
        if (0 == iDirection || 2 == iDirection)
		{
			//
            ptStart0.x = ptArrow_start0.x;
            ptStart0.y = ptArrow_start0.y;// + 4;

            ptArrow_end.x = ptStart0.x ;
            ptArrow_end.y = ptStart0.y + 20;

            graphics.DrawLine(&pen, ptStart0.x, ptStart0.y, ptArrow_end.x, ptArrow_end.y);
		}
        if (1 == iDirection || 2 == iDirection)
		{
			// 
            ptStart0.x = ptArrow_start0.x;
            ptStart0.y = ptArrow_start0.y - 8;

            ptArrow_end.x = ptStart0.x ;
            ptArrow_end.y = ptStart0.y - 20;

            graphics.DrawLine(&pen, ptStart0.x, ptStart0.y, ptArrow_end.x, ptArrow_end.y);
		}		
	}

}

/*********************************************************
  Function:	OnChkDrawPolygon
  Desc:		Draw Polygon or not. 
  Input:	
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::OnChkDrawPolygon() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_bDrawPolygon)
	{
		m_bNeedRedraw[m_iCurRuleID] = TRUE;//Draw polygon
		m_bSetMaxFilter = FALSE;//While drawing polygon, can't draw filter
		m_bSetMiniFilter = FALSE;
	
	}
	else
	{
		if (m_bNeedRedraw[m_iCurRuleID] && !m_bCloseIn[m_iCurRuleID])
		{
			if (m_bMouseMove[m_iCurRuleID])
			{
				m_bMouseMove[m_iCurRuleID] = FALSE;
				m_struVcaPolygon[m_iCurRuleID].dwPointNum--;
			}
			m_bCloseIn[m_iCurRuleID] = TRUE;
		}		
	}	
	UpdateData(FALSE);

}

/*********************************************************
  Function:	OnCheckFilterActive
  Desc:		Check if the size filter is valid
  Input:	
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::OnCheckFilterActive() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	GetDlgItem(IDC_CHECK_SET_MAX_FILTER)->EnableWindow(m_bFilterActive);
	GetDlgItem(IDC_CHECK_SET_MINI_FILTER)->EnableWindow(m_bFilterActive);
}

/*********************************************************
  Function:	OnCheckSetMiniFilter
  Desc:		Set the minimal filter area
  Input:	
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::OnCheckSetMiniFilter() 
{
	// TODO: Add your control notification handler code here
	if (m_lPlayHandle < 0)
	{
		return;
	}
	UpdateData(TRUE);
	if (m_bSetMiniFilter)
	{
		m_bSetMaxFilter = FALSE;
		m_bDrawPolygon = FALSE;
		m_bDrawLine	= FALSE;
		UpdateData(FALSE);
	}
}

/*********************************************************
  Function:	OnCheckSetMaxFilter
  Desc:		Set the maximal filter area.
  Input:	
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::OnCheckSetMaxFilter() 
{
	// TODO: Add your control notification handler code here
	if (m_lPlayHandle < 0)
	{
		return;
	}
	UpdateData(TRUE);
	if (m_bSetMaxFilter)
	{
		m_bSetMiniFilter = FALSE;
		m_bDrawPolygon = FALSE;
		m_bDrawLine = FALSE;
		UpdateData(FALSE);
	}
}

/*********************************************************
  Function:	OnChkDrawLine
  Desc:		Check control for Drawing line
  Input:	
  Output:	
  Return: void 	
**********************************************************/
void CDlgVcaRuleCfg::OnChkDrawLine() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_bDrawLine)//drawing
	{
		if (m_bMouseMove[m_iCurRuleID])
		{
			m_bMouseMove[m_iCurRuleID] = FALSE;
		}
		m_bSetMaxFilter = FALSE;
		m_bSetMiniFilter = FALSE;
		UpdateData(FALSE);
	}
	else
	{
		m_bMouseMove[m_iCurRuleID] = TRUE;
	}	

}

/*********************************************************
  Function:	OnSelchangeComlinealarmdirect
  Desc:		Modify the way to cross the alarm plane
  Input:	
  Output:	
  Return:	void 	
**********************************************************/
void CDlgVcaRuleCfg::OnSelchangeComlinealarmdirect() 
{
	VCA_CROSS_DIRECTION iDirect;
	iDirect = (VCA_CROSS_DIRECTION)m_comboAlarmDirect.GetCurSel();
	m_struOneRule.uEventParam.struTraversePlane.dwCrossDirection = iDirect;
}

/*********************************************************
Function:	SetOneRule
Desc:		Set one rule
Input:	struVcaOneRule
Output:	
Return:	void 	
**********************************************************/
BOOL CDlgVcaRuleCfg::SetOneRule(NET_VCA_ONE_RULE &struVcaOneRule)
{

	UpdateData(TRUE);
	
	//Parameter of Behavior analysis
	SetVcaEventPara(struVcaOneRule.uEventParam,struVcaOneRule.dwEventType);
	
	// Size filter 
	struVcaOneRule.struSizeFilter.byActive = (BYTE)m_bFilterActive;

	SetTimePara();//Fortify time 
	memcpy(&m_struOneRule.struAlarmTime[0][0], 
		&m_struAlarmTime[0][0], (MAX_DAYS*MAX_TIMESEGMENT_2*sizeof(NET_DVR_SCHEDTIME)));
	
	// Alarm linkage (Action after getting alarm)
	SetAlarmPara(struVcaOneRule.struHandleType);//Set alarm info
	/*Camera triggered to record. Set 1 to trigger this channel*/
	SetRelRecordChan(struVcaOneRule, m_iChannelnumber);

	SetRuleBehaviorCfg();
	return TRUE;
}

/*********************************************************
  Function:	OnTimeOk
  Desc:		
  Input:	
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::OnTimeOk() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (!F_TimeTest())
	{
		return;
	}
	int	i = m_comboWeekday.GetCurSel();	
	m_struAlarmTime[i][0].byStartHour = (BYTE)m_iHour11;
	m_struAlarmTime[i][0].byStartMin = (BYTE)m_iMin11;
	m_struAlarmTime[i][0].byStopHour =(BYTE) m_iHour12;
	m_struAlarmTime[i][0].byStopMin = (BYTE)m_iMin12;
	m_struAlarmTime[i][1].byStartHour = (BYTE)m_iHour21;
	m_struAlarmTime[i][1].byStartMin = (BYTE)m_iMin21;
	m_struAlarmTime[i][1].byStopHour = (BYTE)m_iHour22;
	m_struAlarmTime[i][1].byStopMin = (BYTE)m_iMin22;
	GetDlgItem(IDC_TIME_COPY)->EnableWindow(TRUE);
}
/*********************************************************
  Function:	OnTimeCopy
  Desc:		
  Input:	
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::OnTimeCopy() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int j,k;
	int i = m_comboWeekday.GetCurSel();
	int m_nCopyTime = m_comboCopyTime.GetCurSel() - 1;
	
	if(m_nCopyTime == -1)
	{
		for(j=0; j<MAX_DAYS; j++)
		{
			if(j == i)
				continue;
			for(k=0; k<MAX_TIMESEGMENT_2; k++)
			{
				memcpy(&(m_struAlarmTime[j][k]), &(m_struAlarmTime[i][k]), sizeof(NET_DVR_SCHEDTIME));
			}
		}
	}
	else
	{
		for(k=0; k<MAX_TIMESEGMENT_2; k++)
		{
			memcpy(&(m_struAlarmTime[m_nCopyTime][k]), &(m_struAlarmTime[i][k]), sizeof(NET_DVR_SCHEDTIME));
		}
	}

}

/*********************************************************
Function:	F_TimeTest
Desc:		Check Fortify time
Input:	
Output:	
Return:	BOOL
**********************************************************/
BOOL CDlgVcaRuleCfg::F_TimeTest()
{
	int i, j;
	WORD wStartTime[4], wStopTime[4];
	
	UpdateData(TRUE);
	if( (m_iHour11 < 0) || (m_iHour11 > 24) || (m_iHour12 < 0) || (m_iHour12 > 24) ||	\
		(m_iHour21 < 0) || (m_iHour21 > 24) || (m_iHour22 < 0) || (m_iHour22 > 24) )
	{
		AfxMessageBox("Hours range 0 - 24 !");
		return FALSE;
	}
	if( (m_iMin11 < 0) || (m_iMin11 > 60) || (m_iMin12 < 0) || (m_iMin12 > 60) ||	\
		(m_iMin21 < 0) || (m_iMin21 > 60) || (m_iMin22 < 0) || (m_iMin22 > 60) )
	{
		AfxMessageBox("Minute range 0 - 60!");
		return FALSE;
	}
	wStartTime[0] = (WORD)(m_iHour11 * 100 + m_iMin11);
	wStartTime[1] = (WORD)(m_iHour21 * 100 + m_iMin21);
	wStopTime[0] = (WORD)(m_iHour12 * 100 + m_iMin12);
	wStopTime[1] = (WORD)(m_iHour22 * 100 + m_iMin22);
	for(i = 0; i < MAX_TIMESEGMENT_2; i++)
	{
		if( (wStartTime[i] > 2400) || (wStopTime[i] > 2400) )
		{
			char szLan[128] = {0};
			g_StringLanType(szLan, "ʱ䲻ܳ24:00", "Fortify time can not be more than 24:00");
			AfxMessageBox(szLan);
			return FALSE;
		}
		if(wStartTime[i] > wStopTime[i])
		{
			char szLan[128] = {0};
			g_StringLanType(szLan, "ʼʱ䲻ֹܴͣʱ", "Fortify start time can not be larger than the record to stop time");
			AfxMessageBox(szLan);
			return FALSE;
		}
		for(j = 0; j < MAX_TIMESEGMENT_2; j++)
		{
			if (i == j)
				continue;
			if( (wStartTime[i] > wStartTime[j]) && (wStartTime[i] < wStopTime[j]) ||	\
				(wStopTime[i] > wStartTime[j]) && (wStopTime[i] < wStopTime[j]) )
			{
				char szLan[128] = {0};
				g_StringLanType(szLan, "ʱβظ!","Fortify time period can not be repeated!");
				AfxMessageBox(szLan);
				return FALSE;
			}
		}
	}
	return TRUE;
}

/*********************************************************
  Function:	OnSelchangeComboweekday
  Desc:		
  Input:	
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::OnSelchangeComboweekday() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int	i = m_comboWeekday.GetCurSel();	
	m_iHour11 = m_struAlarmTime[i][0].byStartHour;
	m_iMin11 = m_struAlarmTime[i][0].byStartMin;
	m_iHour12 = m_struAlarmTime[i][0].byStopHour;
	m_iMin12 = m_struAlarmTime[i][0].byStopMin;
	m_iHour21 = m_struAlarmTime[i][1].byStartHour;
	m_iMin21 = m_struAlarmTime[i][1].byStartMin;
	m_iHour22 = m_struAlarmTime[i][1].byStopHour;
	m_iMin22 = m_struAlarmTime[i][1].byStopMin;
	UpdateData(FALSE);
}

/*********************************************************
Function:	SetTimePara
Desc:	    ñʱ
Input:	
Output:	
Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::SetTimePara()
{
	int i;
	i = m_comboWeekday.GetCurSel();	
	m_struAlarmTime[i][0].byStartHour = (BYTE)m_iHour11;
	m_struAlarmTime[i][0].byStartMin = (BYTE)m_iMin11;
	m_struAlarmTime[i][0].byStopHour = (BYTE)m_iHour12;
	m_struAlarmTime[i][0].byStopMin = (BYTE)m_iMin12;
	m_struAlarmTime[i][1].byStartHour = (BYTE)m_iHour21;
	m_struAlarmTime[i][1].byStartMin = (BYTE)m_iMin21;
	m_struAlarmTime[i][1].byStopHour = (BYTE)m_iHour22;
	m_struAlarmTime[i][1].byStopMin = (BYTE)m_iMin22;
}

/*********************************************************
Function:	SetAlarmPara	
Desc:	    ñϱͲ
Input:	
Output:	
Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::SetAlarmPara(NET_DVR_HANDLEEXCEPTION_V30 &struHandleType)
{

	UpdateData(TRUE);
	struHandleType.dwHandleType = 0;
	struHandleType.dwHandleType |= (m_bHandleType1 << 0);
	struHandleType.dwHandleType |= (m_bHandleType2 << 1);
	struHandleType.dwHandleType |= (m_bHandleType3 << 2);
	struHandleType.dwHandleType |= (m_bHandleType4 << 3);
	struHandleType.dwHandleType |= (m_bHandleType5 << 4);
	
	for (DWORD i = 0; i < m_dwAlarmOutNum; i++)
	{
		struHandleType.byRelAlarmOut[i] = (BYTE)m_listAlarmOut.GetCheck(i);
	}
	
	
}

/*********************************************************
Function:	SetRelRecordChan
Desc:	    ¼ 
Input:	
Output:	
Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::SetRelRecordChan(NET_VCA_ONE_RULE &struVcaOneRule, int nChanNum)
{
	for (int i = 0; i < nChanNum; i++)
	{
		struVcaOneRule.byRelRecordChan[i] = (BYTE)m_listRecordChan.GetCheck(i);
	}
}

/*********************************************************
Function:	SetVcaEventPara
Desc:	    ¼Ͳ 
Input:  	VCA_EVENT_TYPE struEventType NET_VCA_EVENT_UNION &uEventparam
Output:	    NET_VCA_EVENT_UNION &uEventparam
Return:	    void 
**********************************************************/
void CDlgVcaRuleCfg::SetVcaEventPara(NET_VCA_EVENT_UNION &uEventparam, VCA_EVENT_TYPE struEventType)
{
	switch (struEventType)
	{
	case VCA_TRAVERSE_PLANE:
		memcpy(&uEventparam.struTraversePlane.struPlaneBottom, &m_struVcaLine[m_iCurRuleID], sizeof(NET_VCA_LINE));
		uEventparam.struTraversePlane.dwCrossDirection = (VCA_CROSS_DIRECTION)m_comboAlarmDirect.GetCurSel();
		break;
	case VCA_ENTER_AREA:
		memcpy(&uEventparam.struArea.struRegion, &m_struVcaPolygon[m_iCurRuleID], sizeof(NET_VCA_POLYGON));
		break;
	case VCA_EXIT_AREA:
		memcpy(&uEventparam.struArea.struRegion, &m_struVcaPolygon[m_iCurRuleID], sizeof(NET_VCA_POLYGON));
		break;
	case VCA_INTRUSION:
		uEventparam.struIntrusion.wDuration = (WORD)m_iAlarmDelay;
		memcpy(&uEventparam.struIntrusion.struRegion, &m_struVcaPolygon[m_iCurRuleID], sizeof(NET_VCA_POLYGON));
		break;
	case VCA_LOITER:
		uEventparam.struLoiter.wDuration = (WORD)m_iAlarmPersist;
		memcpy(&uEventparam.struLoiter.struRegion, &m_struVcaPolygon[m_iCurRuleID], sizeof(NET_VCA_POLYGON));
		break;
	case VCA_LEFT_TAKE:
		uEventparam.struTakeTeft.wDuration = (WORD)m_iAlarmPersist;
		memcpy(&uEventparam.struTakeTeft.struRegion, &m_struVcaPolygon[m_iCurRuleID], sizeof(NET_VCA_POLYGON));
		break;
	case VCA_PARKING:
		uEventparam.struParking.wDuration = (WORD)m_iAlarmPersist;
		memcpy(&uEventparam.struParking.struRegion, &m_struVcaPolygon[m_iCurRuleID], sizeof(NET_VCA_POLYGON));
		break;
	case VCA_RUN:
		uEventparam.struRun.fRunDistance = m_fMaxDistance;
		memcpy(&uEventparam.struRun.struRegion, &m_struVcaPolygon[m_iCurRuleID], sizeof(NET_VCA_POLYGON));
		break;
	case VCA_HIGH_DENSITY:
		uEventparam.struHighDensity.fDensity = m_fDenstityRate;
		memcpy(&uEventparam.struHighDensity.struRegion, &m_struVcaPolygon[m_iCurRuleID], sizeof(NET_VCA_POLYGON));
		break;
	case VCA_STICK_UP:
		memcpy(&uEventparam.struStickUp.struRegion, &m_struVcaPolygon[m_iCurRuleID], sizeof(NET_VCA_POLYGON));
		uEventparam.struStickUp.wDuration = (WORD)m_iAlarmPersist;
//		uEventparam.struStickUp.bySensitivity = (BYTE)(m_comboSensitive.GetCurSel()+1);
		break;
	case VCA_INSTALL_SCANNER:
		memcpy(&uEventparam.struScanner.struRegion, &m_struVcaPolygon[m_iCurRuleID], sizeof(NET_VCA_POLYGON));
		uEventparam.struScanner.wDuration = (WORD)m_iReadCardTimePersist;
//		uEventparam.struScanner.bySensitivity = (BYTE)(m_comboSensitive.GetCurSel()+1);
		break;
	default:
		break;
	}
}

/*********************************************************
  Function:	OnCheckhandletype4
  Desc:		
  Input:	
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::OnCheckhandletype4() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_listAlarmOut.EnableWindow(m_bHandleType4);
}

/*********************************************************
  Function:	SetRuleBehaviorCfg
  Desc:		Setup Behavior Analysis Rule
  Input:	
  Output:	
  Return:	
**********************************************************/
void CDlgVcaRuleCfg::SetRuleBehaviorCfg()
{
	char szlan[128] = {0};
	char sbufCn[128] = {0};
	char sbufEn[128] = {0};
	memcpy(&m_struRuleCfg.struRule[m_iCurRuleID], &m_struOneRule, sizeof(NET_VCA_ONE_RULE));	
	if (!NET_DVR_SetDVRConfig(m_lServerID, NET_DVR_SET_RULECFG, m_iVcaChannel, &m_struRuleCfg, sizeof(NET_VCA_RULECFG)))
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_DVR_SET_RULECFG %d", m_iVcaChannel);
		sprintf(sbufCn, "Set Behavior Rule of channel %d failed", m_iVcaChannel);
		sprintf(sbufEn, "Fail to Set Channal%d VCA behavior rule", m_iVcaChannel);
		g_StringLanType(szlan, sbufCn, sbufEn);
		AfxMessageBox(szlan);
		RefreshBehavior(m_iCurRuleID);
	}
	else//save config
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_DVR_SET_RULECFG %d", m_iVcaChannel);
		sprintf(sbufCn, "Set Behavior Rule of channel %d Successfully", m_iVcaChannel);
		sprintf(sbufEn, "Success to Set Channal%d VCA behavior rule", m_iVcaChannel);
		g_StringLanType(szlan, sbufCn, sbufEn);
		AfxMessageBox(szlan);
	}
}

/*********************************************************
  Function:	OnChangeEditRuleName
  Desc:		Modify rule name
  Input:	
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::OnChangeEditRuleName() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	memset(&m_struOneRule.byRuleName[0], 0, sizeof(BYTE)*NAME_LEN);
	strncpy((char*)&m_struOneRule.byRuleName[0], m_csRuleName.GetBuffer(0), (NAME_LEN - 1));
}

/*********************************************************
  Function:	OnChangeEditAlarmDelay
  Desc:		
  Input:	
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::OnChangeEditAlarmDelay() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
//	UpdateData(TRUE);
	
}

/*********************************************************
  Function:	OnChangeEditAlarmPersist
  Desc:		
  Input:	
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::OnChangeEditAlarmPersist() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
//	UpdateData(TRUE);
}

/*********************************************************
  Function:	OnChangeEditDenstityRate
  Desc:		
  Input:	
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::OnChangeEditDenstityRate() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
//	UpdateData(TRUE);
}

/*********************************************************
  Function:	OnChangeEditMaxDistance
  Desc:		
  Input:	
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::OnChangeEditMaxDistance() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
//	UpdateData(TRUE);
}

/*********************************************************
  Function:	OnChangeEditReadCardTimePersist
  Desc:		
  Input:	
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::OnChangeEditReadCardTimePersist() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
//	UpdateData(TRUE);
}

/*********************************************************
Function:InsertComboVcaType
Desc: According to device's ability type, insert type to m_comboVcaType
Input:	
Output:	
Return:	void 
**********************************************************/
BOOL CDlgVcaRuleCfg::InsertComboVcaType()
{
	m_comboVcaType.ResetContent();
	int index = 0;
	if (m_iBBaseChanNum > 0)
	{
		char szLan[128] = {0};
		g_StringLanType(szLan, "Ϊ", "Behavior of the basic version");
		m_comboVcaType.InsertString(index, szLan);
		m_comboVcaType.SetItemData(index, 1);
		index++;
	}
	if (m_iBAdvanceChanNum > 0)
	{
		char szLan[128] = {0};
		g_StringLanType(szLan, "Ϊ߼", "Behavior of the advanced version");
		m_comboVcaType.InsertString(index, szLan);
		m_comboVcaType.SetItemData(index, 2);
		index++;
	}
	if (m_iBFullChanNum > 0)
	{
		char szLan[128] = {0};
		g_StringLanType(szLan, "Ϊ", "Behavior of the full version");
		m_comboVcaType.InsertString(index, szLan);
		m_comboVcaType.SetItemData(index, 3);
		index++;
	}
	if (m_iPlateChanNum > 0)
	{
		char szLan[128] = {0};
		g_StringLanType(szLan, "ʶ", "License Plate Recognition");
		m_comboVcaType.InsertString(index, szLan);
		m_comboVcaType.SetItemData(index, 4);
		index++;
	}
	if (m_iAtmChanNum > 0)
	{
		m_comboVcaType.InsertString(index, "ATM");
		m_comboVcaType.SetItemData(index, 5);
	}
	return TRUE;
}

/*********************************************************
Function:SetComboVcaType
Desc:   
Input:	
Output:	
Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::SetComboVcaType()
{
	int nIndex = 0;
	
	if (m_iBBaseChanNum > 0)
	{
		nIndex++;
	}
	if (m_iBAdvanceChanNum > 0)
	{
		nIndex++;
	}
	if (m_iBFullChanNum > 0)
	{
		nIndex++;
	}
	if (m_iPlateChanNum > 0)
	{
		nIndex++;
	}
	if (m_iAtmChanNum > 0)
	{
		nIndex++;
	}
	for (int i = 0; i < nIndex; i++)
	{
		if (m_comboVcaType.GetItemData(i) == m_struVcaCtrlCfg.struCtrlInfo[m_iVcaChannel-1].byVCAType )
		{
			m_comboVcaType.SetCurSel(i);
			return;
		}
		
	}
}
/*********************************************************
  Function:	RefreshBehavior
  Desc:		refresh Behavior control
  Input:	int iRuleID
  Output:	
  Return:	void 
**********************************************************/
void CDlgVcaRuleCfg::RefreshBehavior(int iRuleID)
{
	memset(&m_struRuleCfg, 0,sizeof(NET_VCA_RULECFG));
	DWORD dwReturned;
	char szLan[128] = {0};
	if(!NET_DVR_GetDVRConfig(m_lServerID, NET_DVR_GET_RULECFG, m_iVcaChannel, &m_struRuleCfg, sizeof(NET_VCA_RULECFG), &dwReturned))	
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_DVR_GET_RULECFG %d", m_iVcaChannel);
		char sbufCn[128] = {0};
		char sbufEn[128] = {0};
		sprintf(sbufCn, "ȡͨ%dΪϢʧ",  m_iVcaChannel);
		sprintf(sbufEn, "Fail to get Channel%d VCA behavior rule", m_iVcaChannel);
		g_StringLanType(szLan, sbufCn, sbufEn);
		AfxMessageBox(szLan);
        OnCancel();

	}
	else
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_DVR_GET_RULECFG %d", m_iVcaChannel);
	}
	m_comboProPicType.SetCurSel(m_struRuleCfg.byPicProType); //Get actions for alarm
	m_comboResolution.SetCurSel(m_struRuleCfg.struPictureParam.wPicSize);//image resolution
	m_comboPicQuality.SetCurSel(m_struRuleCfg.struPictureParam.wPicQuality);//image quality
	
	m_comboRuleID.SetCurSel(iRuleID);
	memcpy(&m_struOneRule, &m_struRuleCfg.struRule[iRuleID], sizeof(NET_VCA_ONE_RULE));
	
	GetEventTypeSet(m_struOneRule.dwEventType);
	m_bRuleActive = m_struOneRule.byActive;
	EnableRuleWindow(m_bRuleActive);
	SetRuleActiveAble(m_bRuleActive);
	//rule name
	m_csRuleName = m_struRuleCfg.struRule[iRuleID].byRuleName;
	

	
	memcpy(&m_struAlarmTime[0][0],&m_struOneRule.struAlarmTime[0][0], MAX_DAYS*MAX_TIMESEGMENT_2*sizeof(NET_DVR_SCHEDTIME));
	
	RefreshOneRule(m_struOneRule);
}

/*********************************************************
  Function:	OnBtnEnterRegion
  Desc:		
  Input:	
  Output:	
  Return:	void
**********************************************************/
void CDlgVcaRuleCfg::OnBtnEnterRegion() 
{
	// TODO: Add your control notification handler code here
	if(!GetEnterRegion())
	{
		return;
	}
	
	CIVMSAtmRegion dlg;
	dlg.m_lServerID = m_lServerID;
	dlg.m_iChannel = m_iVcaChannel;
	memcpy(&(dlg.m_struVCAEnterRegion), &m_struVcaAtmEnterRegion, sizeof(NET_VCA_ENTER_REGION));
	if (dlg.DoModal()==IDOK)
	{
		memcpy(&m_struVcaAtmEnterRegion, &(dlg.m_struVCAEnterRegion), sizeof(NET_VCA_ENTER_REGION));
		SetEnterRegion();
	}	

}

/*********************************************************
  Function:	OnBtnMaskRegion
  Desc:		
  Input:	
  Output:	
  Return:	
**********************************************************/
void CDlgVcaRuleCfg::OnBtnMaskRegion() 
{
	// TODO: Add your control notification handler code here
	if (!GetMaskRegion())
	{
		return;
	}
	
	CIVMSMaskRegion dlg;
	dlg.m_lServerID = m_lServerID;
	dlg.m_iChannel = m_iVcaChannel;
	memcpy(&(dlg.m_struIVMSMaskRegionList), &m_struVcaAtmMaskRegionList, sizeof(NET_VCA_MASK_REGION_LIST));
	if (dlg.DoModal()==IDOK)
	{
		memcpy(&m_struVcaAtmMaskRegionList, &(dlg.m_struIVMSMaskRegionList), sizeof(NET_VCA_MASK_REGION_LIST));
		SetMaskRegion();
	}	
}

/*********************************************************
Function:GetMaskRegion
Desc:  
Input:	
Output:	
Return:	BOOL
**********************************************************/
BOOL CDlgVcaRuleCfg::GetMaskRegion()
{
	DWORD dwReturned = 0;
	if(!NET_DVR_GetDVRConfig(m_lServerID, NET_DVR_GET_VCA_MASK_REGION, m_iVcaChannel, &m_struVcaAtmMaskRegionList, sizeof(NET_VCA_MASK_REGION_LIST), &dwReturned))	
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_DVR_GET_VCA_MASK_REGION %d", m_iVcaChannel);
		AfxMessageBox("Fail to get VCA mask region");
		//OnCancel();
		return FALSE;
	}
	else
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_DVR_GET_VCA_MASK_REGION %d", m_iVcaChannel);
	}
	return TRUE;
	
}

/*********************************************************
Function:GetEnterRegion
Desc:   
Input:	
Output:	
Return:	BOOL
**********************************************************/
BOOL CDlgVcaRuleCfg::GetEnterRegion()
{
	DWORD dwReturned = 0 ;
	if(!NET_DVR_GetDVRConfig(m_lServerID, NET_DVR_GET_VCA_ENTER_REGION, m_iVcaChannel, &m_struVcaAtmEnterRegion, sizeof(NET_VCA_ENTER_REGION), &dwReturned))	
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_DVR_GET_VCA_ENTER_REGION %d", m_iVcaChannel);
		AfxMessageBox("Fail to get VCA enter region");
		//OnCancel();
		return FALSE;
	}
	else
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_DVR_GET_VCA_ENTER_REGION %d", m_iVcaChannel);
	}
	return TRUE;	
}


/*********************************************************
Function:SetMaskRegion	
Desc:   
Input:	
Output:	
Return:	void
**********************************************************/
void CDlgVcaRuleCfg::SetMaskRegion()
{
	if (!NET_DVR_SetDVRConfig(m_lServerID, NET_DVR_SET_VCA_MASK_REGION, m_iVcaChannel, &m_struVcaAtmMaskRegionList, sizeof(NET_VCA_MASK_REGION_LIST)))
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_DVR_SET_VCA_MASK_REGION %d", m_iVcaChannel);
		AfxMessageBox("Fail to set VCA mask region");
	}
	else
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_DVR_SET_VCA_MASK_REGION %d", m_iVcaChannel);
		
	}	
	
}

/*********************************************************
Function:SetEnterRegion	
Desc:   
Input:	
Output:	
Return:	void
**********************************************************/
void CDlgVcaRuleCfg::SetEnterRegion()
{
	if (!NET_DVR_SetDVRConfig(m_lServerID, NET_DVR_SET_VCA_ENTER_REGION, m_iVcaChannel, &m_struVcaAtmEnterRegion, sizeof(NET_VCA_ENTER_REGION)))
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_FAIL_T, "NET_DVR_SET_VCA_ENTER_REGION %d", m_iVcaChannel);
		AfxMessageBox("Fail to set VCA Enter region");
	}
	else
	{
		g_pMainDlg->AddLog(m_iDevIndex, OPERATION_SUCC_T, "NET_DVR_SET_VCA_ENTER_REGION %d", m_iVcaChannel);
		
	}		
	
}
