// MatDispChanControl.cpp : implementation file
//

#include "stdafx.h"
#include "clientdemo.h"
#include "MatDispChanControl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMatDispChanControl dialog

CMatDispChanControl::CMatDispChanControl(CWnd* pParent /*=NULL*/)
	: CDialog(CMatDispChanControl::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMatDispChanControl)
	//}}AFX_DATA_INIT
    for(int i = 0; i < 16; i ++)
    {
        memset(&m_DispChanCfg[i], 0, sizeof(NET_DVR_VGA_DISP_CHAN_CFG));
    }    
}


void CMatDispChanControl::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMatDispChanControl)
	DDX_Control(pDX, IDC_COMBOVEDIOFORMAT, m_VedioFormatCtrl);
	DDX_Control(pDX, IDC_COMBOAUDIOSUBWNW, m_comboAudioWindow);
	DDX_Control(pDX, IDC_COMBOSUBWINDOWDECCHAN, m_ComboSubWindowDecChan);
	DDX_Control(pDX, IDC_COMBOSUBWINDOWNUM, m_ComboSubWindowNum);
	DDX_Control(pDX, IDC_COMBODISPCHAN, m_ComboDispChan);
	DDX_Control(pDX, IDC_COMBOOPENAUDIO, m_ComboOpenAudio);
	DDX_Control(pDX, IDC_COMBOPICMODE, m_ComboPicMode);
	DDX_Control(pDX, IDC_COMBOVGARESOLURION, m_ComboVgaResolution);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMatDispChanControl, CDialog)
	//{{AFX_MSG_MAP(CMatDispChanControl)
	ON_CBN_SELCHANGE(IDC_COMBODISPCHAN, OnSelchangeCombodispchan)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
// 	ON_BN_CLICKED(IDC_CLOSEAUDIO, OnCloseaudio)
// 	ON_BN_CLICKED(IDC_OPENAUDIO, OnOpenaudio)
	ON_BN_CLICKED(IDC_RENEWWINDOW, OnRenewwindow)
	ON_BN_CLICKED(IDC_ENLARGEWINDOW, OnEnlargewindow)
	ON_BN_CLICKED(IDC_DISPCHANCFG, OnDispchancfg)
	ON_CBN_SELCHANGE(IDC_COMBOSUBWINDOWNUM, OnSelchangeCombosubwindownum)
	ON_BN_CLICKED(IDC_SURE, OnSure)
	ON_BN_CLICKED(IDC_SUBSURE, OnSubsure)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMatDispChanControl message handlers

BOOL CMatDispChanControl::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
    CString tmp;

    memset(&m_Ability, 0, sizeof(NET_DVR_MATRIX_ABILITY));
    if (!NET_DVR_GetDeviceAbility(m_lServerID, MATRIXDECODER_ABILITY, NULL, 0, (char*)&m_Ability, sizeof(NET_DVR_MATRIX_ABILITY)))
    {
        tmp.Format("Error code : %d", NET_DVR_GetLastError());
        AfxMessageBox(tmp);
        return FALSE;
    }
    else
    {        
        m_lStartChan = m_Ability.byStartChan;
        m_iChannelNumber = m_Ability.byDecNums;
        m_iVGANums = m_Ability.byVGANums;
        m_iBNCNums = m_Ability.byBNCNums;
    }
    
    DWORD dwReturned = 0;
    memset(&m_struDeviceCfg, 0, sizeof(NET_DVR_DEVICECFG));
    if (!NET_DVR_GetDVRConfig(m_lServerID, NET_DVR_GET_DEVICECFG, 0, &m_struDeviceCfg, sizeof(NET_DVR_DEVICECFG), &dwReturned))
    {
        MessageBox("Get Device Parameter Failed!");
    }

    int i = 0;
    int ChanNo = -1;
    char szLan[128] = {0};
    TRACE("\nm_iChannelnumber = %d\n", m_iChannelNumber);
    for(i = 0; i < m_iVGANums; i++)
    {
        ChanNo = m_lStartChan + i;
        g_StringLanType(szLan, "VGA", "VGA");
        tmp.Format("%s %d", szLan, ChanNo);
        m_ComboDispChan.InsertString(i, tmp);
    }

    for(i = m_iVGANums; i < m_iBNCNums + m_iVGANums; i++)
    {
        ChanNo = m_lStartChan + i;
        g_StringLanType(szLan, "BNC", "BNC");
        tmp.Format("%s %d", szLan, ChanNo - m_iVGANums);
        m_ComboDispChan.InsertString(i, tmp);
    }

	if (m_struDeviceCfg.byDVRType == 28)
	{
		m_ComboDispChan.InsertString(i, "HDMI");
		m_ComboDispChan.InsertString(i + 1, "DVI");
		m_ComboDispChan.InsertString(i + 2, "BNC");
	}

	if (m_struDeviceCfg.byDVRType == DS_6504D_B10)
	{
		m_ComboDispChan.ResetContent();
		m_ComboDispChan.InsertString(0, "HDMI/DVI");
	}

    for(i = 0; i < m_iChannelNumber; i++)
    {
        ChanNo = m_lStartChan + i;
        g_StringLanType(szLan, "ͨ", "Chan");
        tmp.Format("%s %d", szLan, ChanNo);
        m_ComboSubWindowDecChan.InsertString(i, tmp);
    }
    
    for(i = 0; i < m_iVGANums; i++)
    {
        if (!NET_DVR_MatrixGetDisplayCfg(m_lServerID, i + m_lStartChan, &m_DispChanCfg[i]))
        {
            TRACE("\nError: NET_DVR_MatrixGetLoopDecChanInfo[%d] = %d\n", i, NET_DVR_GetLastError());
        }
    }
    for(i = m_iVGANums; i < m_iBNCNums + m_iVGANums; i++)
    {
        if (!NET_DVR_MatrixGetDisplayCfg(m_lServerID, 9 + i - m_iVGANums, &m_DispChanCfg[i]))
        {
            TRACE("\nError: NET_DVR_MatrixGetLoopDecChanInfo[%d] = %d\n", i, NET_DVR_GetLastError());
        }
    }    
 
    UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
    
void CMatDispChanControl::OnSelchangeCombodispchan() 
{
	UpdateData(TRUE);
    int sel = m_ComboDispChan.GetCurSel();
    int i = 0;
    CString sTemp;
    m_ComboPicMode.ResetContent();
    m_ComboVgaResolution.ResetContent();
    int iMaxWindows = 0;
    if (m_ComboDispChan.GetCurSel() < m_iVGANums)
    {
        for (i = 0; i < 12; i++)
        {
            if (m_Ability.byVGAWindowMode[m_ComboDispChan.GetCurSel()][i] != 0)
            {
                sTemp.Format("%d", m_Ability.byVGAWindowMode[m_ComboDispChan.GetCurSel()][i]);
                m_ComboPicMode.InsertString(i, sTemp);
            }
        }

        GetDlgItem(IDC_COMBOVGARESOLURION)->EnableWindow(TRUE);
		for (i = 0; i < 32; i ++)
		{
			if (m_Ability.bySupportResolution[i] == 1)
			{
				m_ComboVgaResolution.AddString(struResolutin[i].sResolutionName);
			}
		}
    }
    else if ((m_ComboDispChan.GetCurSel() == m_iVGANums + m_iBNCNums) && (m_struDeviceCfg.byDVRType == 28))
    {
        m_ComboPicMode.InsertString(0, "1");
        m_ComboPicMode.InsertString(1, "2");
        m_ComboPicMode.InsertString(2, "4");
        m_ComboPicMode.InsertString(3, "9");
        m_ComboPicMode.InsertString(4, "16");
        m_ComboVgaResolution.InsertString(0, "HDMI_720P");
        m_ComboVgaResolution.InsertString(1, "HDMI_1080I");
        m_ComboVgaResolution.InsertString(2, "HDMI_1080P");
    }
    else if ((m_ComboDispChan.GetCurSel() == m_iVGANums + m_iBNCNums + m_lStartChan) && (m_struDeviceCfg.byDVRType == 28))
    {        
        m_ComboPicMode.InsertString(0, "1");
        m_ComboPicMode.InsertString(1, "2");
        m_ComboPicMode.InsertString(2, "4");
        m_ComboPicMode.InsertString(3, "9");
        m_ComboPicMode.InsertString(4, "16");
        m_ComboVgaResolution.InsertString(0, "DVI_XGA");
        m_ComboVgaResolution.InsertString(1, "DVI_SXGA");
        m_ComboVgaResolution.InsertString(2, "DVI_720P");
        m_ComboVgaResolution.InsertString(3, "DVI_1080I");
        m_ComboVgaResolution.InsertString(4, "DVI_1080P");
        m_ComboVgaResolution.InsertString(5, "DVI_UXGA");
    }
	else if ((m_ComboDispChan.GetCurSel() == 2) && (m_struDeviceCfg.byDVRType == 28))
	{
		m_ComboVgaResolution.InsertString(0, "NOT_AVALIABLE");
	}
    else
    {
        GetDlgItem(IDC_COMBOVGARESOLURION)->EnableWindow(FALSE);
        for (i = 0; i < 4; i++)
        {
            if (m_Ability.byBNCWindowMode[i] != 0)
            {
                sTemp.Format("%d", m_Ability.byBNCWindowMode[i]);
                m_ComboPicMode.InsertString(i, sTemp);
            }
        }
    }
    m_ComboSubWindowNum.ResetContent();
    m_comboAudioWindow.ResetContent();
    if (m_ComboDispChan.GetCurSel() < m_iVGANums)
    {
        for (i = 0; i < 12; i++)
        {
            if (m_Ability.byVGAWindowMode[m_ComboDispChan.GetCurSel()][i] > iMaxWindows)
            {
                iMaxWindows = m_Ability.byVGAWindowMode[m_ComboDispChan.GetCurSel()][i];
            }
        }
        for(i = 1; i <= iMaxWindows; i++)
        {
            sTemp.Format("%d", i);
            m_ComboSubWindowNum.InsertString(i - 1, sTemp);
            m_comboAudioWindow.InsertString(i - 1, sTemp);
        }
    }
    else
    {
        for (i = 0; i < 4; i++)
        {
            if (m_Ability.byBNCWindowMode[i] > iMaxWindows)
            {
                iMaxWindows = m_Ability.byBNCWindowMode[i];
            }
        }
        for(i = 1; i <= iMaxWindows; i++)
        {
            sTemp.Format("%d", i);
            m_ComboSubWindowNum.InsertString(i - 1, sTemp);
            m_comboAudioWindow.InsertString(i - 1, sTemp);
        }
    }

    m_ComboOpenAudio.SetCurSel(m_DispChanCfg[sel].byAudio);
    switch(m_DispChanCfg[sel].dwWindowMode) 
    {
    case 1:
        m_ComboPicMode.SetCurSel(0);
        break;
    case 2:
        m_ComboPicMode.SetCurSel(1);
        break;
    case 4:
        m_ComboPicMode.SetCurSel(2);
        break;
    case 9:
        m_ComboPicMode.SetCurSel(3);
        break;
    case 16:
        m_ComboPicMode.SetCurSel(4);
        break;
    default:
        m_ComboPicMode.SetCurSel(-1);
        break;
    }

    m_VedioFormatCtrl.SetCurSel(m_DispChanCfg[sel].byVedioFormat - 1);
    switch(m_DispChanCfg[sel].byVgaResolution) 
    {
    case 3:
        m_ComboVgaResolution.SetCurSel(0);
        break;
    case 5:
        m_ComboVgaResolution.SetCurSel(1);
        break;
    case 6:
        m_ComboVgaResolution.SetCurSel(2);
        break;
    case 10:
    case 11:
    case 12:
        m_ComboVgaResolution.SetCurSel(m_DispChanCfg[sel].byVgaResolution - 10);
        break;
    case 13:
    case 14:
    case 15:
    case 16:
    case 17:
    case 18:
        m_ComboVgaResolution.SetCurSel(m_DispChanCfg[sel].byVgaResolution - 13);
        break;
    default:
        m_ComboVgaResolution.SetCurSel(-1);
        break;
    }

    m_comboAudioWindow.SetCurSel(m_DispChanCfg[sel].byAudioWindowIdx - 1);
    int subsel = m_ComboSubWindowNum.GetCurSel();
    m_ComboSubWindowDecChan.SetCurSel(m_DispChanCfg[sel].byJoinDecChan[subsel] - m_lStartChan);
    UpdateData(FALSE);
}

void CMatDispChanControl::OnExit() 
{
    CDialog::OnCancel();
}

void CMatDispChanControl::OnRenewwindow() 
{
    UpdateData(TRUE);
    int sel = m_ComboDispChan.GetCurSel();
    if(sel < m_iVGANums)
    {
        if (!NET_DVR_MatrixDiaplayControl(m_lServerID, sel + m_lStartChan, DISP_CMD_RENEW_WINDOW , m_ComboSubWindowNum.GetCurSel() + m_lStartChan))
        {
            CString sTemp;
            sTemp.Format("ERROR: NET_DVR_MatrixDiaplayControl = %d \n", NET_DVR_GetLastError());
            AfxMessageBox(sTemp);
        }	
    }
    else
    {
        if (!NET_DVR_MatrixDiaplayControl(m_lServerID, 9 + sel - m_iVGANums, DISP_CMD_RENEW_WINDOW , m_ComboSubWindowNum.GetCurSel() + m_lStartChan))
        {
            CString sTemp;
            sTemp.Format("ERROR: NET_DVR_MatrixDiaplayControl = %d \n", NET_DVR_GetLastError());
            AfxMessageBox(sTemp);
        }	
    }
}

void CMatDispChanControl::OnEnlargewindow() 
{
    UpdateData(TRUE);
    int sel = m_ComboDispChan.GetCurSel();
    if(sel < m_iVGANums)
    {
        if (!NET_DVR_MatrixDiaplayControl(m_lServerID, sel + m_lStartChan, DISP_CMD_ENLARGE_WINDOW , m_ComboSubWindowNum.GetCurSel() + m_lStartChan))
        {
            CString sTemp;
            sTemp.Format("ERROR: NET_DVR_MatrixDiaplayControl = %d \n", NET_DVR_GetLastError());
            AfxMessageBox(sTemp);
        }	
    }
    else
    {
        if (!NET_DVR_MatrixDiaplayControl(m_lServerID, 9 + sel - m_iVGANums, DISP_CMD_ENLARGE_WINDOW , m_ComboSubWindowNum.GetCurSel() + m_lStartChan))
        {
            CString sTemp;
            sTemp.Format("ERROR: NET_DVR_MatrixDiaplayControl = %d \n", NET_DVR_GetLastError());
            AfxMessageBox(sTemp);
        }	
    }
}

void CMatDispChanControl::OnDispchancfg() 
{
    UpdateData(TRUE);
    CString str;
    int sel = m_ComboDispChan.GetCurSel();
    if(m_ComboDispChan.GetCurSel() < m_iVGANums)
    {
        
        TRACE("sel = %d, m_DispChanCfg[sel].byJoinDecChan[0] = %d", sel, m_DispChanCfg[sel].byJoinDecChan[0]);
        if (!NET_DVR_MatrixSetDisplayCfg(m_lServerID, sel + m_lStartChan, &m_DispChanCfg[sel])) 
        {
            str.Format("Error code : %d", NET_DVR_GetLastError());
            AfxMessageBox(str);
            return;
        }
    }
    else if((m_ComboDispChan.GetCurSel() >= m_iVGANums + m_iBNCNums) && (m_struDeviceCfg.byDVRType == 28))
    {
        if (!NET_DVR_MatrixSetDisplayCfg(m_lServerID, m_lStartChan, &m_DispChanCfg[sel])) 
        {
            str.Format("Error code : %d", NET_DVR_GetLastError());
            AfxMessageBox(str);
            return;
        }
    }
    else
    {
        if (!NET_DVR_MatrixSetDisplayCfg(m_lServerID, 9 + sel - m_iVGANums, &m_DispChanCfg[sel])) 
        {
            str.Format("Error code : %d", NET_DVR_GetLastError());
            AfxMessageBox(str);
            return;
        }
    }

    AfxMessageBox("Set Success");
}

void CMatDispChanControl::OnSelchangeCombosubwindownum() 
{
    m_ComboSubWindowDecChan.SetCurSel(m_DispChanCfg[m_ComboDispChan.GetCurSel()].byJoinDecChan[m_ComboSubWindowNum.GetCurSel()] - m_lStartChan);
    UpdateData(FALSE);
}

void CMatDispChanControl::OnSure() 
{
	UpdateData(TRUE);
    int sel = m_ComboDispChan.GetCurSel();
	char temp[20] = {0};
	m_ComboVgaResolution.GetLBText(m_ComboVgaResolution.GetCurSel(), temp);

	for (int i = 0; i < 64; i++)
	{
		if (strcmp(temp, struResolutin[i].sResolutionName) == 0)
		{
			m_DispChanCfg[sel].byVgaResolution = struResolutin[i].dwResolutionSeq;
			break;
		}

		if (struResolutin[i].dwResolutionSeq == 33)
		{
			break;
		}
	}

	m_ComboPicMode.GetLBText(m_ComboPicMode.GetCurSel(), temp);
	CString str;
	for (i = 1; i <= 16; i++)
	{
		str.Format("%d", i);
		if (strcmp(temp, str) == 0)
		{
			m_DispChanCfg[sel].dwWindowMode = i;
			break;
		}
	}

    m_DispChanCfg[sel].byVedioFormat = m_VedioFormatCtrl.GetCurSel() + 1;
	
    m_DispChanCfg[sel].byAudioWindowIdx = m_comboAudioWindow.GetCurSel() + 1;
    int subWindowsel = m_ComboSubWindowNum.GetCurSel();
    
    m_DispChanCfg[sel].byJoinDecChan[subWindowsel] = m_ComboSubWindowDecChan.GetCurSel() + m_lStartChan;
    TRACE("sel = %d, subWindowsel = %d , m_DispChanCfg[sel].byJoinDecChan[subWindowsel] = %d", sel, subWindowsel, m_DispChanCfg[sel].byJoinDecChan[subWindowsel]);
}

void CMatDispChanControl::OnSubsure() 
{
    UpdateData(TRUE);
    int sel = m_ComboDispChan.GetCurSel();
    int subWindowsel = m_ComboSubWindowNum.GetCurSel();
    int i = m_ComboSubWindowDecChan.GetCurSel();
    m_DispChanCfg[sel].byJoinDecChan[subWindowsel] = m_ComboSubWindowDecChan.GetCurSel() + m_lStartChan;
    TRACE("sel = %d, subWindowsel = %d , m_DispChanCfg[sel].byJoinDecChan[subWindowsel] = %d", sel, subWindowsel, m_DispChanCfg[sel].byJoinDecChan[subWindowsel]);
}

void CMatDispChanControl::OnClear() 
{
    UpdateData(TRUE);

    int sel = m_ComboDispChan.GetCurSel();

    memset(&m_DispChanCfg[sel], 0, sizeof(NET_DVR_VGA_DISP_CHAN_CFG));
}
