// MatDynamicTest.cpp : implementation file
//

#include "stdafx.h"
#include "clientdemo.h"
#include "MatDynamicTest.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMatDynamicTest dialog


CMatDynamicTest::CMatDynamicTest(CWnd* pParent /*=NULL*/)
	: CDialog(CMatDynamicTest::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMatDynamicTest)
	m_RemoteIP = _T("172.7.103.253");
	m_RemotePort = 8000;
	m_RemoteSurveillace = 1;
	m_RemoteUser = _T("admin");
	m_RemotePass = _T("12345");
	m_strStreamMediaIp = _T("172.7.162.100");
	m_dwStreamMediaPort = 8888;
	m_bUseStreamMedia = FALSE;
	//}}AFX_DATA_INIT
}


void CMatDynamicTest::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMatDynamicTest)
	DDX_Control(pDX, IDC_COMBOSTREAMMEDIAPRO, m_ComboStreamMediaPro);
	DDX_Control(pDX, IDC_COMBODECCHANNUM, m_DecChanCombo);
	DDX_Control(pDX, IDC_COMBOTRANSMODE, m_TransModeCombo);
	DDX_Control(pDX, IDC_COMBOPROTOCOL, m_TransProtocolCombo);
	DDX_Text(pDX, IDC_EDITREMOTEIP, m_RemoteIP);
	DDX_Text(pDX, IDC_EDITREMOTEPORT, m_RemotePort);
	DDX_Text(pDX, IDC_EDITREMOTESURVE, m_RemoteSurveillace);
	DDX_Text(pDX, IDC_EDITREMOTENAME, m_RemoteUser);
	DDX_Text(pDX, IDC_EDITREMOTEPASS, m_RemotePass);
	DDX_Text(pDX, IDC_STREAMMEDIAIP, m_strStreamMediaIp);
	DDX_Text(pDX, IDC_STREAMMEDIAPORT, m_dwStreamMediaPort);
	DDX_Check(pDX, IDC_USESTREAMMEDIA, m_bUseStreamMedia);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMatDynamicTest, CDialog)
	//{{AFX_MSG_MAP(CMatDynamicTest)
	ON_BN_CLICKED(IDC_STARTDYNAMIC, OnStartdynamic)
	ON_BN_CLICKED(IDC_STOPDYNAMIC, OnStopdynamic)
	ON_BN_CLICKED(IDC_USESTREAMMEDIA, OnUsestreammedia)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMatDynamicTest message handlers

void CMatDynamicTest::OnStartdynamic() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	
	NET_DVR_PU_STREAM_CFG dt;
	ZeroMemory(&dt, sizeof(dt));
	dt.dwSize = sizeof(NET_DVR_PU_STREAM_CFG);
	dt.struDevChanInfo.byChannel = (BYTE)m_RemoteSurveillace;
	dt.struDevChanInfo.byTransMode = m_TransModeCombo.GetCurSel();
	dt.struDevChanInfo.byTransProtocol = m_TransProtocolCombo.GetCurSel();
	sprintf((char *)dt.struDevChanInfo.sPassword, "%s", m_RemotePass);
	sprintf((char *)dt.struDevChanInfo.sUserName, "%s", m_RemoteUser);
	sprintf(dt.struDevChanInfo.struIP.sIpV4, "%s", m_RemoteIP);
	dt.struDevChanInfo.wDVRPort = m_RemotePort;
	
    dt.struStreamMediaSvrCfg.byValid = m_bUseStreamMedia;
    if (m_bUseStreamMedia)
    {
        dt.struStreamMediaSvrCfg.wDevPort = m_dwStreamMediaPort;
        dt.struStreamMediaSvrCfg.byTransmitType = m_ComboStreamMediaPro.GetCurSel();
        sprintf(dt.struStreamMediaSvrCfg.struDevIP.sIpV4, "%s", m_strStreamMediaIp);
    }

	if (!NET_DVR_MatrixStartDynamic_V30(m_lServerID, m_DecChanCombo.GetCurSel()+m_lStartChan, &dt))
	{
		CString tmp;
		tmp.Format("Error: NET_DVR_MatrixStartDynamic = %d\n", NET_DVR_GetLastError());
		AfxMessageBox(tmp);
		return;
	}
	MessageBox("ɹ!");
}

void CMatDynamicTest::OnStopdynamic() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	if (!NET_DVR_MatrixStopDynamic(m_lServerID, m_DecChanCombo.GetCurSel() + m_lStartChan))
	{
		TRACE("\nError: NET_DVR_MatrixStopDynamic = %d\n", NET_DVR_GetLastError());
        CString str;
        str.Format("Error Code : %d", NET_DVR_GetLastError());
        AfxMessageBox(str);
		return;
	}
	char szLan[128] = {0};
	g_StringLanType(szLan, "ɹֹͣ", "Stop successfully");
	AfxMessageBox(szLan);
}

BOOL CMatDynamicTest::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CString tmp;
	char szLan[128] = {0};
	g_StringLanType(szLan, "ͨ", "Channel");
	for (int i=0; i<m_iChannelnumber;i++)
	{
		tmp.Format("%s%d", szLan, i + m_lStartChan);
		m_DecChanCombo.AddString(tmp);
	}
	m_DecChanCombo.SetCurSel(0);
	m_TransProtocolCombo.SetCurSel(0);
	m_TransModeCombo.SetCurSel(0);
    m_bUseStreamMedia = 0;
	UpdateData(FALSE);
    OnUsestreammedia();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMatDynamicTest::OnUsestreammedia() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
    if (m_bUseStreamMedia)
    {
        GetDlgItem(IDC_STREAMMEDIAIP)->EnableWindow(TRUE);
        GetDlgItem(IDC_STREAMMEDIAPORT)->EnableWindow(TRUE);
        GetDlgItem(IDC_COMBOSTREAMMEDIAPRO)->EnableWindow(TRUE);
    }
    else
    {
        GetDlgItem(IDC_STREAMMEDIAIP)->EnableWindow(FALSE);
        GetDlgItem(IDC_STREAMMEDIAPORT)->EnableWindow(FALSE);
        GetDlgItem(IDC_COMBOSTREAMMEDIAPRO)->EnableWindow(FALSE);
    }
    UpdateData(FALSE);
}
